#!/bin/sh

if [ "$buildpath" == "" ]; then
	buildpath="`pwd`"
fi
PathDg87d="$buildpath/../src/dg87d/dg87d"
PathDg87r="$buildpath/../src/dg87r/dg87r"
PathDg87x="$buildpath/../src/dg87x/dg87x"

PathDiocmd="$buildpath/../src/diocmd/diocmd"
PathDgd="$buildpath/../src/diocmd/dgd"
PathDgx="$buildpath/../src/diocmd/dgx"
PathDgr="$buildpath/../src/diocmd/dgr"

alias dgd="$PathDgd --"
alias dgr="$PathDgr --"
alias dgx="$PathDgx --"
dayDate=`date +"%Y-%m-%d %H:%M"`
JOBPATH=$buildpath/$srcdir/jobs
export DG87_USER="admin"
export DG87_PASSWORD=""

################################################################################
function checkNoDaemon()
{
if [ "`ps ax | grep 'dg87[xdr]' | wc -l`" -ne 0 ]; then
	echo "ERROR : one or more diogene87 daemons are already running !"; 
	exit 1
fi
}
################################################################################
function dg87d(){
$PathDgd -C "$buildpath/$srcdir/diocmd.conf" -- $*
}
################################################################################
function stopDg87d()
{
killall dg87d >/dev/null 2>&1
}
################################################################################
function startDg87d()
{
stopDg87d
if [ ! -f $PathDg87d ] ; then
	echo "Can't find dg87d : $PathDg87d"
	return 1
fi
`$PathDg87d -C $buildpath/$srcdir/dg87d.conf -dN`
sleep 1
dg87d version > /dev/null
if [ $? != 0 ] ; then
	echo "Can't communicate with dg87d"
	return 1;
fi
}
################################################################################
function dg87r(){
$PathDgr -C "$buildpath/$srcdir/diocmd.conf" -- $*
}
################################################################################
function stopDg87r()
{
killall dg87r >/dev/null 2>&1
}
################################################################################
function startDg87r()
{
stopDg87r
if [ ! -f $PathDg87r ] ; then
	echo "Can't find dg87r : $PathDg87r"
	return 1
fi
`$PathDg87r -C $buildpath/$srcdir/dg87r.conf -dN`
sleep 1
dg87r version > /dev/null
if [ $? != 0 ] ; then
	echo "Can't communicate with dg87r"
	return 1;
fi
}
################################################################################
function dg87x(){
$PathDgx -C "$buildpath/$srcdir/diocmd.conf" -- $*
}
################################################################################
function stopDg87x()
{
killall dg87x >/dev/null 2>&1
}
################################################################################
function startDg87x()
{
stopDg87x
if [ ! -f $PathDg87x ] ; then
	echo "Can't find dg87x : $PathDg87x"
	return 1
fi
`$PathDg87x -C $buildpath/$srcdir/dg87x.conf -dN`
sleep 1
dg87x version > /dev/null
if [ $? != 0 ] ; then
	echo "Can't communicate with dg87x"
	return 1;
fi
}
################################################################################
