#!/bin/sh
#
# file tst01.sh 
#
#      Diogene87
#	Copyright (C) 2003 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#

if [ "$srcdir" == "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Start dg87d"
startDg87d || exit 1 || exit 1
echo "Start dg87x"
startDg87x || exit 1 || exit 1
echo "Start dg87r"
startDg87r || exit 1 || exit 1

# dg87d : test memory 
mem1=`dgd memory`
if [ $? != 0 ] ; then echo "error"; exit 1; fi
mem2=`dgd memory`
if [ $? != 0 ] ; then echo "error"; exit 1; fi
if [ $mem1 != $mem2 ] ; then
	echo "dg87d : memory error between two calls $mem1 -> $mem2"
	exit 1
fi

# dg87x test memory 
mem1=`dgx memory`
if [ $? != 0 ] ; then echo "error"; exit 1; fi
mem2=`dgx memory`
if [ $? != 0 ] ; then echo "error"; exit 1; fi
if [ $mem1 != $mem2 ] ; then
	echo "dg87x : memory error between two calls $mem1 -> $mem2"
	exit 1
fi

# dg87r : test memory 
mem1=`dgr memory`
if [ $? != 0 ] ; then echo "error"; exit 1; fi
mem2=`dgr memory`
if [ $? != 0 ] ; then echo "error"; exit 1; fi
if [ $mem1 != $mem2 ] ; then
	echo "dg87r : memory error between two calls $mem1 -> $mem2 "
	exit 1
fi

echo "Stop dg87d"
stopDg87d || exit 1 || exit 1
echo "Stop dg87x"
stopDg87x || exit 1 || exit 1
echo "Stop dg87r"
stopDg87r || exit 1 || exit 1
