#!/bin/sh
#
# file tst06.sh 
# (test job dependences)
#
#      Diogene87
#	Copyright (C) 2003 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" == "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Start dg87d"
startDg87d || exit 1
echo "Start dg87x"
startDg87x || exit 1
echo "Start dg87r"
startDg87r || exit 1


# dg87x
dgx ta localhost || exit 1
dgx qa localhost q1 || exit 1
dgx tso localhost true || exit 1
dgx qso localhost q1 true || exit 1
dgx ese true || exit 1

# dg87d
dgd ta localhost || exit 1
dgd qa localhost q1 || exit 1

######################################## a task whitout jobs
echo "Test a task whithout jobs"
memx1=`dgx memory`
dgd ra r1 || exit 1
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2
if [ "`dgx xti d1 t1 | grep State | awk '{print $2}'`" != "terminated" ]; then
	echo "Task isn't terminated."
fi
dgd rk r1 || exit 1
dgx xdk d1 || exit 1
memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## a task with a job 
echo "Test a task with a job"
memx1=`dgx memory`
dgd ra r1 || exit 1
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2
if [ "`dgx xji d1 t1 j1 | grep State | awk '{print $2}'`" != "terminated" ]; 
then
	echo "Job isn't terminated."; exit 1
fi
if [ "`dgx xti d1 t1 | grep State | awk '{print $2}'`" != "terminated" ]; then
	echo "Task isn't terminated."; exit 1
fi
if [ "`dgx xji d1 t1 j1 | grep "Exit code"| awk '{print $3}'`" != "0" ]; then
	echo "Exit code is not good."; exit 1
fi
if [ "`dgx qxjc localhost q1`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dgd rk r1 || exit 1
dgx xdk d1 || exit 1
memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi
######################################## a task with an aborted job
echo "Test a task with an aborted job"
memx1=`dgx memory`
dgd ra r1 || exit 1
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2
if [ "`dgx xji d1 t1 j1 | grep State | awk '{print $2}'`" != "aborted" ]; 
then
	echo "Job isn't aborted."; exit 1
fi
if [ "`dgx xti d1 t1 | grep State | awk '{print $2}'`" != "aborted" ]; then
	echo "Task isn't aborted."; exit 1
fi
if [ "`dgx xji d1 t1 j1 | grep "Exit code"| awk '{print $3}'`" != "22" ]; then
	echo "Exit code is not good."; exit 1
fi
if [ "`dgx qxjc localhost q1`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dgd rk r1 || exit 1
dgx xdk d1 || exit 1
memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## a task with two jobs
echo "Test a task with two jobs"
memx1=`dgx memory`
dgd ra r1 || exit 1
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job2.sh"
dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2
if [ "`dgx xji d1 t1 j1 | grep State | awk '{print $2}'`" != "terminated" ]; 
then 
	echo "Job1 isn't terminated." ; exit 1
fi
if [ "`dgx xji d1 t1 j2 | grep State | awk '{print $2}'`" != "terminated" ]; 
then 
	echo "Job2 isn't terminated." ; exit 1
fi
if [ "`dgx xti d1 t1 | grep State | awk '{print $2}'`" != "terminated" ]; then
	echo "Task isn't terminated."; exit 1
fi
if [ "`dgx qxjc localhost q1`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dgd rk r1 || exit 1
dgx xdk d1 || exit 1
memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## a task with dependence (always)
echo "Test job dependence (type always with normal termination)"
memx1=`dgx memory`
dgd ra r1 || exit 1
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job2.sh"
dgd rjda r1 t1 j1 j2 always || exit 1
dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2
if [ "`dgx xji d1 t1 j1 | grep State | awk '{print $2}'`" != "terminated" ]; 
then 
	echo "Job1 isn't terminated." ; exit 1
fi
if [ "`dgx xji d1 t1 j2 | grep State | awk '{print $2}'`" != "terminated" ]; 
then 
	echo "Job2 isn't terminated." ; exit 1
fi
if [ "`dgx xti d1 t1 | grep State | awk '{print $2}'`" != "terminated" ]; then
	echo "Task isn't terminated."; exit 1
fi
if [ "`dgx qxjc localhost q1`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dgd rk r1 || exit 1
dgx xdk d1 || exit 1
memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## a task with dependence (always)
echo "Test job dependence (type always with abort)"
memx1=`dgx memory`
dgd ra r1 || exit 1
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job2.sh"
dgd rjda r1 t1 j1 j2 always || exit 1
dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2
if [ "`dgx xji d1 t1 j1 | grep State | awk '{print $2}'`" != "aborted" ]; 
then 
	echo "Job1 isn't aborted." ; exit 1
fi
if [ "`dgx xji d1 t1 j2 | grep State | awk '{print $2}'`" != "terminated" ]; 
then 
	echo "Job2 isn't terminated." ; exit 1
fi
if [ "`dgx xti d1 t1 | grep State | awk '{print $2}'`" != "aborted" ]; then
	echo "Task isn't aborted."; exit 1
fi
if [ "`dgx qxjc localhost q1`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dgd rk r1 || exit 1
dgx xdk d1 || exit 1
memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## a task with dependence (onsuccess)
echo "Test job dependence (type onsuccess with normal termination)"
memx1=`dgx memory`
dgd ra r1 || exit 1
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job2.sh"
dgd rjda r1 t1 j1 j2 onsuccess || exit 1
dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2
if [ "`dgx xji d1 t1 j1 | grep State | awk '{print $2}'`" != "terminated" ]; 
then 
	echo "Job1 isn't terminated." ; exit 1
fi
if [ "`dgx xji d1 t1 j2 | grep State | awk '{print $2}'`" != "terminated" ]; 
then 
	echo "Job2 isn't terminated." ; exit 1
fi
if [ "`dgx xti d1 t1 | grep State | awk '{print $2}'`" != "terminated" ]; then
	echo "Task isn't terminated."; exit 1
fi
if [ "`dgx qxjc localhost q1`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dgd rk r1 || exit 1
dgx xdk d1 || exit 1
memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## a task with dependence (onsuccess)
echo "Test job dependence (type onsuccess with abort)"
memx1=`dgx memory`
dgd ra r1 || exit 1
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job2.sh"
dgd rjda r1 t1 j1 j2 onsuccess || exit 1
dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2
if [ "`dgx xji d1 t1 j1 | grep State | awk '{print $2}'`" != "aborted" ]; 
then 
	echo "Job1 isn't aborted." ; exit 1
fi
if [ "`dgx xji d1 t1 j2 | grep State | awk '{print $2}'`" != "canceled" ]; 
then 
	echo "Job2 isn't canceled." ; exit 1
fi
if [ "`dgx xti d1 t1 | grep State | awk '{print $2}'`" != "aborted" ]; then
	echo "Task isn't aborted."; exit 1
fi
if [ "`dgx qxjc localhost q1`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dgd rk r1 || exit 1
dgx xdk d1 || exit 1
memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## a task with dependence (onerror)
echo "Test job dependence (type onerror with normal termination)"
memx1=`dgx memory`
dgd ra r1 || exit 1
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job2.sh"
dgd rjda r1 t1 j1 j2 onerror || exit 1
dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2
if [ "`dgx xji d1 t1 j1 | grep State | awk '{print $2}'`" != "terminated" ]; 
then 
	echo "Job1 isn't terminated." ; exit 1
fi
if [ "`dgx xji d1 t1 j2 | grep State | awk '{print $2}'`" != "canceled" ]; 
then 
	echo "Job2 isn't canceled." ; exit 1
fi
if [ "`dgx xti d1 t1 | grep State | awk '{print $2}'`" != "terminated" ]; then
	echo "Task isn't terminated."; exit 1
fi
if [ "`dgx qxjc localhost q1`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dgd rk r1 || exit 1
dgx xdk d1 || exit 1
memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## a task with dependence (onerror)
echo "Test job dependence (type onerror with abort)"
memx1=`dgx memory`
dgd ra r1 || exit 1
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job2.sh"
dgd rjda r1 t1 j1 j2 onerror || exit 1
dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2
if [ "`dgx xji d1 t1 j1 | grep State | awk '{print $2}'`" != "aborted" ]; 
then 
	echo "Job1 isn't aborted." ; exit 1
fi
if [ "`dgx xji d1 t1 j2 | grep State | awk '{print $2}'`" != "terminated" ]; 
then 
	echo "Job2 isn't terminated." ; exit 1
fi
if [ "`dgx xti d1 t1 | grep State | awk '{print $2}'`" != "aborted" ]; then
	echo "Task isn't aborted."; exit 1
fi
if [ "`dgx qxjc localhost q1`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dgd rk r1 || exit 1
dgx xdk d1 || exit 1
memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi


echo "Stop dg87r"
stopDg87r || exit 1
echo "Stop dg87d"
stopDg87d || exit 1
echo "Stop dg87x"
stopDg87x || exit 1
