#!/bin/sh
#
# file tst10.sh 
# (test enabled property, onErrorContinue property for job and task)
#
#      Diogene87
#	Copyright (C) 2003 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#

if [ "$srcdir" == "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Start dg87d"
startDg87d || exit 1
echo "Start dg87x"
startDg87x || exit 1
echo "Start dg87r"
startDg87r || exit 1

# dg87x
dgx ta localhost || exit 1
dgx qa localhost q1 || exit 1
dgx tso localhost true || exit 1
dgx qso localhost q1 true || exit 1
dgx ese true || exit 1

# dg87d
dgd ta localhost || exit 1
dgd qa localhost q1 || exit 1

######################################## task enabled property 
echo "Test Task enabled property" 
memx1=`dgx memory`
dgd ra r1 || exit 1

dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job1.sh"

dgd rta r1 t2 || exit 1
dgd rtoa r1 t2 add always || exit 1
dgd rtsq r1 t2 localhost q1 || exit 1
dgd rja r1 t2 j1 || exit 1
dgd rjsp r1 t2 j1 "$JOBPATH/job1.sh"

dgd rta r1 t3 || exit 1
dgd rtoa r1 t3 add always || exit 1
dgd rtsq r1 t3 localhost q1 || exit 1
dgd rja r1 t3 j1 || exit 1
dgd rjsp r1 t3 j1 "$JOBPATH/job1.sh"

dgd rtda r1 t1 t2 || exit 1
dgd rtda r1 t2 t3 || exit 1

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xtse d1 t2 false 
if [ $? -ne 0 ]; then echo "Can't disabled task."; exit 1; fi
dgx xdse d1 true || exit 1
sleep 2
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The first task isn't terminated."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t2`" != "t2!wait_enabled" ]; then
	echo "The second task isn't waiting enabled."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t3`" != "t3!wait_for_dep" ]; then
	echo "The third task isn't waiting for dependence."; exit 1
fi
dgx xtse d1 t2 true 
if [ $? -ne 0 ]; then echo "Can't enabled task."; exit 1; fi
sleep 2
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The first task isn't terminated."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t2`" != "t2!terminated" ]; then
	echo "The second task isn't terminated."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t3`" != "t3!terminated" ]; then
	echo "The third task isn't terminated."; exit 1
fi
dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi


######################################## job enabled property 
echo "Test Job enabled property" 
memx1=`dgx memory`
dgd ra r1 || exit 1
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1

dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job1.sh"
dgd rja r1 t1 j3 || exit 1
dgd rjsp r1 t1 j3 "$JOBPATH/job1.sh"

dgd rjda r1 t1 j1 j2 || exit 1
dgd rjda r1 t1 j2 j3 || exit 1

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xjse d1 t1 j2 false 
if [ $? -ne 0 ]; then echo "Can't disabled job."; exit 1; fi
dgx xdse d1 true || exit 1
sleep 2
if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!terminated" ]; then
	echo "The first job isn't terminated."; exit 1
fi
if [ "`dgx xjl -sS! d1 t1 | grep j2`" != "j2!wait_enabled" ]; then
	echo "The second job isn't waiting enabled."; exit 1
fi
if [ "`dgx xjl -sS! d1 t1 | grep j3`" != "j3!wait_for_dep" ]; then
	echo "The third job isn't waiting for dependence."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!running" ]; then
	echo "The task isn't running."; exit 1
fi
dgx xjse d1 t1 j2 true 
if [ $? -ne 0 ]; then echo "Can't enabled job."; exit 1; fi
sleep 2
if [ "`dgx xjl -sS! d1 t1 | grep j2`" != "j2!terminated" ]; then
	echo "The second job isn't terminated."; exit 1
fi
if [ "`dgx xjl -sS! d1 t1 | grep j3`" != "j3!terminated" ]; then
	echo "The third job isn't terminated."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The task isn't terminated."; exit 1
fi

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## job onerrorcontinue=false with abort
echo "Test Job with OnErrorContinue=false with abort" 
memx1=`dgx memory`

dgd ra r1 || exit 1

dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1

dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dgd rjsoec r1 t1 j1 false || exit 1

dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job2.sh"

dgd rjda r1 t1 j1 j2 onsuccess

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2

if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!abort_stopped" ]; then
	echo "The first job isn't abort_stopped."; exit 1
fi
if [ "`dgx xjdl -sS! d1 t1`" != "j1!j2!waiting" ]; then
	echo "The job dependence isn't waiting."; exit 1
fi
if [ "`dgx xjl -sS! d1 t1 | grep j2`" != "j2!wait_for_dep" ]; then
	echo "The second job isn't waiting for dep."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!running" ]; then
	echo "The task isn't running."; exit 1
fi

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi


######################################## job onerrorcontinue=false with no abort
echo "Test Job with OnErrorContinue=false with normal termination " 
memx1=`dgx memory`

dgd ra r1 || exit 1
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1

dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dgd rjsoec r1 t1 j1 false || exit 1

dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job2.sh"

dgd rjda r1 t1 j1 j2 onsuccess

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2

if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!terminated" ]; then
	echo "The first job isn't terminated."; exit 1
fi
if [ "`dgx xjdl -sS! d1 t1`" != "j1!j2!validated" ]; then
	echo "The job dependence isn't validated."; exit 1
fi
if [ "`dgx xjl -sS! d1 t1 | grep j2`" != "j2!terminated" ]; then
	echo "The second job isn't terminated."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The task isn't terminated."; exit 1
fi

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi


######################################## job onerrorcontinue=true with abort 
echo "Test Job with OnErrorContinue=true with abort" 
memx1=`dgx memory`

dgd ra r1 || exit 1
# first task
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1

dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dgd rjsoec r1 t1 j1 true || exit 1

dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job2.sh"

dgd rjda r1 t1 j1 j2 onsuccess

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2
if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!aborted" ]; then
	echo "The first job isn't aborted."; exit 1
fi
if [ "`dgx xjdl -sS! d1 t1`" != "j1!j2!canceled" ]; then
	echo "The job dependence isn't canceled."; exit 1
fi
if [ "`dgx xjl -sS! d1 t1 | grep j2`" != "j2!canceled" ]; then
	echo "The second job isn't canceled."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!aborted" ]; then
	echo "The task isn't aborted."; exit 1
fi

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## job onerrorcontinue=true without abort 
echo "Test Job with OnErrorContinue=true with normal termination" 
memx1=`dgx memory`

dgd ra r1 || exit 1
# first task
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1

dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dgd rjsoec r1 t1 j1 true || exit 1

dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job2.sh"

dgd rjda r1 t1 j1 j2 onsuccess

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2
if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!terminated" ]; then
	echo "The job first isn't terminated."; exit 1
fi
if [ "`dgx xjdl -sS! d1 t1`" != "j1!j2!validated" ]; then
	echo "The job dependence isn't validated."; exit 1
fi
if [ "`dgx xjl -sS! d1 t1 | grep j2`" != "j2!terminated" ]; then
	echo "The second job isn't terminated."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The task isn't terminated."; exit 1
fi

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## abort with manual restart 
echo "Test Job abort with manual restart" 
memx1=`dgx memory`

TMPFILE="/tmp/dg87fic$$"
if [ -f $TMPFILE ] ; then
	"File '$TMPFILE' already exists"; exit 1
fi
dgd ra r1 || exit 1
# first task
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1

dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job7.sh"
dgd rjsa r1 t1 j1 "$TMPFILE"
dgd rjsoec r1 t1 j1 false || exit 1

dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job2.sh" || exit 1

dgd rjda r1 t1 j1 j2 onsuccess || exit 1

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2

echo "  Start job with abort"
if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!abort_stopped" ]; then
	echo "The first job isn't abort_stopped."; exit 1
fi
if [ "`dgx xjdl -sS! d1 t1`" != "j1!j2!waiting" ]; then
	echo "The job dependence isn't waiting."; exit 1
fi
if [ "`dgx xjl -sS! d1 t1 | grep j2`" != "j2!wait_for_dep" ]; then
	echo "The second job isn't waiting for dep."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!running" ]; then
	echo "The task isn't running."; exit 1
fi

echo "  Restart job after correction"
# create the file
touch $TMPFILE
if [ $? != 0 ] ; then
	echo "Can't create file $TMPFILE". exit 1
fi
# restart job
dgx xju d1 t1 j1 ready_to_run
if [ $? -ne 0 ] ; then
	echo "Can't restart job"; exit 1
fi
sleep 2

if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!terminated" ]; then
	echo "The first job isn't terminated."; rm $TMPFILE; exit 1
fi
if [ "`dgx xjdl -sS! d1 t1`" != "j1!j2!validated" ]; then
	echo "The job dependence isn't validated."; rm $TMPFILE; exit 1
fi
if [ "`dgx xjl -sS! d1 t1 | grep j2`" != "j2!terminated" ]; then
	echo "The second job isn't terminated."; rm $TMPFILE; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The task isn't terminated."; rm $TMPFILE; exit 1
fi

rm $TMPFILE || exit 1

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## job abort with manual cancel 
echo "Test Job abort with manual cancel" 
memx1=`dgx memory`

dgd ra r1 || exit 1
# first task
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1

dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dgd rjsoec r1 t1 j1 false || exit 1

dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job2.sh" || exit 1

dgd rjda r1 t1 j1 j2 onsuccess || exit 1

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2

echo "  Start job with abort"
if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!abort_stopped" ]; then
	echo "The first job isn't abort_stopped."; exit 1
fi
if [ "`dgx xjdl -sS! d1 t1`" != "j1!j2!waiting" ]; then
	echo "The job dependence isn't waiting."; exit 1
fi
if [ "`dgx xjl -sS! d1 t1 | grep j2`" != "j2!wait_for_dep" ]; then
	echo "The second job isn't waiting for dep."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!running" ]; then
	echo "The task isn't running."; exit 1
fi

echo "  Cancel job"
# cancel job 
dgx xju d1 t1 j1 canceled
if [ $? -ne 0 ] ; then
	echo "Can't cancel job"; exit 1
fi
sleep 1

if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!canceled" ]; then
	echo "The first job isn't canceled."; exit 1
fi
if [ "`dgx xjdl -sS! d1 t1`" != "j1!j2!canceled" ]; then
	echo "The job dependence isn't canceled.";  exit 1
fi
if [ "`dgx xjl -sS! d1 t1 | grep j2`" != "j2!canceled" ]; then
	echo "The second job isn't canceled.";  exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The task isn't terminated.";  exit 1
fi

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## abort with manual validation 
echo "Test Job abort with manual validation" 
memx1=`dgx memory`

dgd ra r1 || exit 1
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1

dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dgd rjsoec r1 t1 j1 false || exit 1

dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job2.sh" || exit 1

dgd rjda r1 t1 j1 j2 onsuccess || exit 1

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2

echo "  Start job with abort"
if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!abort_stopped" ]; then
	echo "The first job isn't abort_stopped."; exit 1
fi
if [ "`dgx xjdl -sS! d1 t1`" != "j1!j2!waiting" ]; then
	echo "The job dependence isn't waiting."; exit 1
fi
if [ "`dgx xjl -sS! d1 t1 | grep j2`" != "j2!wait_for_dep" ]; then
	echo "The second job isn't waiting for dep."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!running" ]; then
	echo "The task isn't running."; exit 1
fi

echo "  validate job termination"
dgx xju d1 t1 j1 terminated 
if [ $? -ne 0 ] ; then
	echo "Can't terminate job"; exit 1
fi
sleep 1

if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!terminated" ]; then
	echo "The first job isn't terminated.";  exit 1
fi
if [ "`dgx xjdl -sS! d1 t1`" != "j1!j2!validated" ]; then
	echo "The job dependence isn't validated.";  exit 1
fi
if [ "`dgx xjl -sS! d1 t1 | grep j2`" != "j2!terminated" ]; then
	echo "The second job isn't terminated.";  exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The task isn't terminated.";  exit 1
fi

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## abort with manual abort validation 
echo "Test Job abort with manual abort validation" 
memx1=`dgx memory`

dgd ra r1 || exit 1
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1

dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dgd rjsoec r1 t1 j1 false || exit 1

dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job2.sh" || exit 1

dgd rjda r1 t1 j1 j2 onsuccess || exit 1

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2

echo "  Start job with abort"
if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!abort_stopped" ]; then
	echo "The first job isn't abort_stopped."; exit 1
fi
if [ "`dgx xjdl -sS! d1 t1`" != "j1!j2!waiting" ]; then
	echo "The job dependence isn't waiting."; exit 1
fi
if [ "`dgx xjl -sS! d1 t1 | grep j2`" != "j2!wait_for_dep" ]; then
	echo "The second job isn't waiting for dep."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!running" ]; then
	echo "The task isn't running."; exit 1
fi

echo "  validate job abort"
dgx xju d1 t1 j1 aborted 0
if [ $? -ne 0 ] ; then
	echo "Can't validate job abort"; exit 1
fi
sleep 1

if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!aborted" ]; then
	echo "The first job isn't aborted."; exit 1
fi
if [ "`dgx xjdl -sS! d1 t1`" != "j1!j2!canceled" ]; then
	echo "The job dependence isn't canceled."; exit 1
fi
if [ "`dgx xjl -sS! d1 t1 | grep j2`" != "j2!canceled" ]; then
	echo "The second job isn't canceled."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!aborted" ]; then
	echo "The task isn't aborted."; exit 1
fi

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## task onerrorcontinue=false with abort
echo "Test task with OnErrorContinue=false and abort" 
memx1=`dgx memory`

dgd ra r1 || exit 1

# first task
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dgd rtsoec r1 t1 false || exit 1

# second task
dgd rta r1 t2 || exit 1
dgd rtoa r1 t2 add always || exit 1
dgd rtsq r1 t2 localhost q1 || exit 1
dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job1.sh"

dgd rtda r1 t1 t2 onsuccess

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2

if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!abort_stopped" ]; then
	echo "The first task isn't abort_stopped."; exit 1
fi
if [ "`dgx xtdl -sS! d1 `" != "t1!t2!waiting" ]; then
	echo "The task dependence isn't waiting."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t2`" != "t2!wait_for_dep" ]; then
	echo "The second task isn't waiting for dep."; exit 1
fi

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

####################################### task onerrorcontinue=false with no abort
echo "Test task with OnErrorContinue=false and no abort" 
memx1=`dgx memory`

dgd ra r1 || exit 1

# first task
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dgd rtsoec r1 t1 false || exit 1

# second task
dgd rta r1 t2 || exit 1
dgd rtoa r1 t2 add always || exit 1
dgd rtsq r1 t2 localhost q1 || exit 1
dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job1.sh"

dgd rtda r1 t1 t2 onsuccess

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2

if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The first task isn't terminated."; exit 1
fi
if [ "`dgx xtdl -sS! d1 `" != "t1!t2!validated" ]; then
	echo "The task dependence isn't validated."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t2`" != "t2!terminated" ]; then
	echo "The second task isn't terminated."; exit 1
fi

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## task onerrorcontinue=true with abort
echo "Test task with OnErrorContinue=true and abort" 
memx1=`dgx memory`

dgd ra r1 || exit 1

# first task
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dgd rtsoec r1 t1 true || exit 1

# second task
dgd rta r1 t2 || exit 1
dgd rtoa r1 t2 add always || exit 1
dgd rtsq r1 t2 localhost q1 || exit 1
dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job1.sh"

dgd rtda r1 t1 t2 onsuccess

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2

if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!aborted" ]; then
	echo "The first task isn't aborted."; exit 1
fi
if [ "`dgx xtdl -sS! d1 `" != "t1!t2!canceled" ]; then
	echo "The task dependence isn't canceled."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t2`" != "t2!canceled" ]; then
	echo "The second task isn't canceled."; exit 1
fi

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## task onerrorcontinue=true with no abort
echo "Test task with OnErrorContinue=true and no abort" 
memx1=`dgx memory`

dgd ra r1 || exit 1

# first task
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dgd rtsoec r1 t1 true || exit 1

# second task
dgd rta r1 t2 || exit 1
dgd rtoa r1 t2 add always || exit 1
dgd rtsq r1 t2 localhost q1 || exit 1
dgd rja r1 t1 j2 || exit 1
dgd rjsp r1 t1 j2 "$JOBPATH/job1.sh"

dgd rtda r1 t1 t2 onsuccess

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2

if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The first task isn't terminated."; exit 1
fi
if [ "`dgx xtdl -sS! d1 `" != "t1!t2!validated" ]; then
	echo "The task dependence isn't validated."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t2`" != "t2!terminated" ]; then
	echo "The second task isn't terminated."; exit 1
fi

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## task abort with manual restart 
echo "Test task abort with manual restart" 
memx1=`dgx memory`

TMPFILE="/tmp/dg87fic$$"
if [ -f $TMPFILE ] ; then
	"File '$TMPFILE' already exists"; exit 1
fi
dgd ra r1 || exit 1

# first task
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job7.sh"
dgd rjsa r1 t1 j1 "$TMPFILE"
dgd rtsoec r1 t1 false || exit 1

# second task
dgd rta r1 t2 || exit 1
dgd rtoa r1 t2 add always || exit 1
dgd rtsq r1 t2 localhost q1 || exit 1
dgd rja r1 t2 j1 || exit 1
dgd rjsp r1 t2 j1 "$JOBPATH/job1.sh"

dgd rtda r1 t1 t2 onsuccess || exit 1

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2

echo "  Start job with abort"
if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!aborted" ]; then
	echo "The job isn't aborted."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!abort_stopped" ]; then
	echo "The first task isn't abort stopped."; exit 1
fi
if [ "`dgx xtdl -sS! d1 `" != "t1!t2!waiting" ]; then
	echo "The task dependence isn't waiting."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t2`" != "t2!wait_for_dep" ]; then
	echo "The second task isn't waiting for dependence."; exit 1
fi

echo "  Restart job after correction"
# create the file
touch $TMPFILE
if [ $? != 0 ] ; then
	echo "Can't create file $TMPFILE". exit 1
fi

# restart job and task
dgx xju d1 t1 j1 ready_to_run
if [ $? -ne 0 ] ; then
	echo "Can't restart job"; exit 1
fi
dgx xtu d1 t1 running 
if [ $? -ne 0 ] ; then
	echo "Can't restart task"; exit 1
fi
sleep 2

if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!terminated" ]; then
	echo "The job isn't terminated."; rm $TMPFILE; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The first task isn't terminated."; rm $TMPFILE; exit 1
fi
if [ "`dgx xtdl -sS! d1 `" != "t1!t2!validated" ]; then
	echo "The task dependence isn't validated."; rm $TMPFILE; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t2`" != "t2!terminated" ]; then
	echo "The second task isn't terminated."; rm $TMPFILE; exit 1
fi

rm $TMPFILE || exit 1

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## task abort with manual cancel 
echo "Test task abort with manual cancel" 
memx1=`dgx memory`

dgd ra r1 || exit 1

# first task
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dgd rjsa r1 t1 j1 "$TMPFILE"
dgd rtsoec r1 t1 false || exit 1

# second task
dgd rta r1 t2 || exit 1
dgd rtoa r1 t2 add always || exit 1
dgd rtsq r1 t2 localhost q1 || exit 1
dgd rja r1 t2 j1 || exit 1
dgd rjsp r1 t2 j1 "$JOBPATH/job1.sh"

dgd rtda r1 t1 t2 onsuccess || exit 1

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2

echo "  Start job with abort"
if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!aborted" ]; then
	echo "The job isn't aborted."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!abort_stopped" ]; then
	echo "The first task isn't abort stopped."; exit 1
fi
if [ "`dgx xtdl -sS! d1 `" != "t1!t2!waiting" ]; then
	echo "The task dependence isn't waiting."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t2`" != "t2!wait_for_dep" ]; then
	echo "The second task isn't waiting for dependence."; exit 1
fi


# cancel task 
echo "  Cancel task"
dgx xtu d1 t1 canceled
if [ $? -ne 0 ] ; then
	echo "Can't cancel task"; exit 1
fi
sleep 1

if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!canceled" ]; then
	echo "The first task isn't canceled."; exit 1
fi
if [ "`dgx xtdl -sS! d1 `" != "t1!t2!canceled" ]; then
	echo "The task dependence isn't canceled.";  exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t2`" != "t2!canceled" ]; then
	echo "The second task isn't canceled.";  exit 1
fi

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi

######################################## task abort with manual validation 
echo "Test task abort with manual validation" 
memx1=`dgx memory`

dgd ra r1 || exit 1

# first task
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dgd rjsa r1 t1 j1 "$TMPFILE"
dgd rtsoec r1 t1 false || exit 1

# second task
dgd rta r1 t2 || exit 1
dgd rtoa r1 t2 add always || exit 1
dgd rtsq r1 t2 localhost q1 || exit 1
dgd rja r1 t2 j1 || exit 1
dgd rjsp r1 t2 j1 "$JOBPATH/job1.sh"

dgd rtda r1 t1 t2 onsuccess || exit 1

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2

echo "  Start job with abort"
if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!aborted" ]; then
	echo "The job isn't aborted."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!abort_stopped" ]; then
	echo "The first task isn't abort stopped."; exit 1
fi
if [ "`dgx xtdl -sS! d1 `" != "t1!t2!waiting" ]; then
	echo "The task dependence isn't waiting."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t2`" != "t2!wait_for_dep" ]; then
	echo "The second task isn't waiting for dependence."; exit 1
fi


# validate task termination 
echo "  Task validation"
dgx xtu d1 t1 terminated 
if [ $? -ne 0 ] ; then
	echo "Can't terminate task"; exit 1
fi
sleep 1

if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The first task isn't terminated."; exit 1
fi
if [ "`dgx xtdl -sS! d1 `" != "t1!t2!validated" ]; then
	echo "The task dependence isn't validated.";  exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t2`" != "t2!terminated" ]; then
	echo "The second task isn't terminated.";  exit 1
fi

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi


####################################### task abort with manual abort validation 
echo "Test task abort with manual abort validation" 
memx1=`dgx memory`

dgd ra r1 || exit 1

# first task
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost q1 || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dgd rjsa r1 t1 j1 "$TMPFILE"
dgd rtsoec r1 t1 false || exit 1

# second task
dgd rta r1 t2 || exit 1
dgd rtoa r1 t2 add always || exit 1
dgd rtsq r1 t2 localhost q1 || exit 1
dgd rja r1 t2 j1 || exit 1
dgd rjsp r1 t2 j1 "$JOBPATH/job1.sh"

dgd rtda r1 t1 t2 onsuccess || exit 1

dgd ese true || exit 1
dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
dgx xdse d1 true || exit 1
sleep 2

echo "  Start job with abort"
if [ "`dgx xjl -sS! d1 t1 | grep j1`" != "j1!aborted" ]; then
	echo "The job isn't aborted."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!abort_stopped" ]; then
	echo "The first task isn't abort stopped."; exit 1
fi
if [ "`dgx xtdl -sS! d1 `" != "t1!t2!waiting" ]; then
	echo "The task dependence isn't waiting."; exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t2`" != "t2!wait_for_dep" ]; then
	echo "The second task isn't waiting for dependence."; exit 1
fi

# validate task abort 
echo "  Task abort validation"
dgx xtu d1 t1 aborted 
if [ $? -ne 0 ] ; then
	echo "Can't abort task"; exit 1
fi
sleep 1

if [ "`dgx xtl -sS! d1 | grep t1`" != "t1!aborted" ]; then
	echo "The first task isn't aborted."; exit 1
fi
if [ "`dgx xtdl -sS! d1 `" != "t1!t2!canceled" ]; then
	echo "The task dependence isn't canceled.";  exit 1
fi
if [ "`dgx xtl -sS! d1 | grep t2`" != "t2!canceled" ]; then
	echo "The second task isn't canceled.";  exit 1
fi

dgd rk r1 || exit 1
dgx xdk d1 || exit 1

memx2=`dgx memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dg87x $memx1 -> $memx2"; exit 1
fi



echo "Stop dg87r"
stopDg87r || exit 1
echo "Stop dg87d"
stopDg87d || exit 1
echo "Stop dg87x"
stopDg87x || exit 1


