#!/bin/sh
#
# file tst20.sh 
# (test task dependence translation)
#
#      Diogene87
#	Copyright (C) 2003 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" == "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Start dg87d"
startDg87d || exit 1
echo "Start dg87x"
startDg87x || exit 1

# dg87d : test 
mem1=`dgd memory`
if [ $? != 0 ] ; then echo "error"; exit 1; fi

################################################## circular reference for task
echo "test task dependence translation (always)" 

# t1 -(a)-> !t2! -(a)-> t3  :  t1 -(a)-> t3
echo " step 1"
dgd ra ref || exit 1
dgd rta ref t1 || exit 1
dgd rtoa ref t1 add always || exit 1
dgd rta ref t2 || exit 1
dgd rta ref t3 || exit 1
dgd rtoa ref t3 add always || exit 1
dgd rtda ref t1 t2 || exit 1
dgd rtda ref t2 t3 || exit 1
dgd ese true || exit 1
dgd rp ref d1 "$dayDate" || exit 1
sleep 1
if [ "`dgx xtdl d1 -tS!`" != "t1!t3!always" ] ; then
	echo "Dependence was not translated"; exit 1
fi
dgx xdk d1 || exit 1
dgd rk ref || exit 1

# t1 -(s)-> !t2! -(a)-> t3  :  t1 -(a)-> t3
echo " step 2"
dgd ra ref || exit 1
dgd rta ref t1 || exit 1
dgd rtoa ref t1 add always || exit 1
dgd rta ref t2 || exit 1
dgd rta ref t3 || exit 1
dgd rtoa ref t3 add always || exit 1
dgd rtda ref t1 t2 onsuccess || exit 1
dgd rtda ref t2 t3 always || exit 1
dgd ese true || exit 1
dgd rp ref d1 "$dayDate" || exit 1
sleep 1
if [ "`dgx xtdl d1 -tS!`" != "t1!t3!always" ] ; then
	echo "Dependence was not translated"; exit 1
fi
dgx xdk d1 || exit 1
dgd rk ref || exit 1

# t1 -(e)-> !t2! -(a)-> t3  : no dependence 
echo " step 3"
dgd ra ref || exit 1
dgd rta ref t1 || exit 1
dgd rtoa ref t1 add always || exit 1
dgd rta ref t2 || exit 1
dgd rta ref t3 || exit 1
dgd rtoa ref t3 add always || exit 1
dgd rtda ref t1 t2 onerror || exit 1
dgd rtda ref t2 t3 always || exit 1
dgd ese true || exit 1
dgd rp ref d1 "$dayDate" || exit 1
sleep 1
if [ "`dgx xtdc d1 `" != "0" ] ; then
	echo "No dependence should be created"; exit 1
fi
dgx xdk d1 || exit 1
dgd rk ref || exit 1

# !t1! -(a)-> !t2! -(a)->t3 : no translation
echo " step 4"
dgd ra ref || exit 1
dgd rta ref t1 || exit 1
dgd rta ref t2 || exit 1
dgd rta ref t3 || exit 1
dgd rtoa ref t3 add always || exit 1
dgd rtda ref t1 t2 || exit 1
dgd rtda ref t2 t3 || exit 1
dgd ese true || exit 1
dgd rp ref d1 "$dayDate" || exit 1
sleep 1
if [ "`dgx xtdc d1 `" != "0" ] ; then
	echo "No dependence should be created"; exit 1
fi
dgx xdk d1 || exit 1
dgd rk ref || exit 1

# t1 -(a)-> !t2! -(a)-> !t3! -(a)-> t4  :  t1 -(a)-> t4
echo " step 5"
dgd ra ref || exit 1
dgd rta ref t1 || exit 1
dgd rtoa ref t1 add always || exit 1
dgd rta ref t2 || exit 1
dgd rta ref t3 || exit 1
dgd rta ref t4 || exit 1
dgd rtoa ref t4 add always || exit 1
dgd rtda ref t1 t2 || exit 1
dgd rtda ref t2 t3 || exit 1
dgd rtda ref t3 t4 || exit 1
dgd ese true || exit 1
dgd rp ref d1 "$dayDate" || exit 1
sleep 1
if [ "`dgx xtdl d1 -tS!`" != "t1!t4!always" ] ; then
	echo "Dependence was not translated"; exit 1
fi
dgx xdk d1 || exit 1
dgd rk ref || exit 1


# t1 -(a)-> !t2! -(a)-> !t3! -(a)->t4  :  t1 -(a)-> t4
echo " step 6"
dgd ra ref || exit 1
dgd rta ref t1 || exit 1
dgd rtoa ref t1 add always || exit 1
dgd rta ref t2 || exit 1
dgd rta ref t3 || exit 1
dgd rta ref t4 || exit 1
dgd rtoa ref t4 add always || exit 1
dgd rtda ref t1 t2 || exit 1
dgd rtda ref t2 t3 || exit 1
dgd rtda ref t3 t4 || exit 1
dgd ese true || exit 1
dgd rp ref d1 "$dayDate" || exit 1
sleep 1
if [ "`dgx xtdl d1 -tS!`" != "t1!t4!always" ] ; then
	echo "Dependence was not translated"; exit 1
fi
dgx xdk d1 || exit 1
dgd rk ref || exit 1

################################################## circular reference for task
echo "test task dependence translation (onsuccess)" 

# t1 -(a)-> !t2! -(s)-> t3  :  t1 -(s)-> t3
echo " step 1"
dgd ra ref || exit 1
dgd rta ref t1 || exit 1
dgd rtoa ref t1 add always || exit 1
dgd rta ref t2 || exit 1
dgd rta ref t3 || exit 1
dgd rtoa ref t3 add always || exit 1
dgd rtda ref t1 t2 always || exit 1
dgd rtda ref t2 t3 onsuccess || exit 1
dgd ese true || exit 1
dgd rp ref d1 "$dayDate" || exit 1
sleep 1
if [ "`dgx xtdl d1 -tS!`" != "t1!t3!onsuccess" ] ; then
	echo "Dependence was not translated"; exit 1
fi
dgx xdk d1 || exit 1
dgd rk ref || exit 1

# t1 -(s)-> !t2! -(s)-> t3  :  t1 -(s)-> t3
echo " step 2"
dgd ra ref || exit 1
dgd rta ref t1 || exit 1
dgd rtoa ref t1 add always || exit 1
dgd rta ref t2 || exit 1
dgd rta ref t3 || exit 1
dgd rtoa ref t3 add always || exit 1
dgd rtda ref t1 t2 onsuccess || exit 1
dgd rtda ref t2 t3 onsuccess || exit 1
dgd ese true || exit 1
dgd rp ref d1 "$dayDate" || exit 1
sleep 1
if [ "`dgx xtdl d1 -tS!`" != "t1!t3!onsuccess" ] ; then
	echo "Dependence was not translated"; exit 1
fi
dgx xdk d1 || exit 1
dgd rk ref || exit 1

# t1 -(e)-> !t2! -(s)-> t3  : no dependence 
echo " step 3"
dgd ra ref || exit 1
dgd rta ref t1 || exit 1
dgd rtoa ref t1 add always || exit 1
dgd rta ref t2 || exit 1
dgd rta ref t3 || exit 1
dgd rtoa ref t3 add always || exit 1
dgd rtda ref t1 t2 onerror || exit 1
dgd rtda ref t2 t3 onsuccess || exit 1
dgd ese true || exit 1
dgd rp ref d1 "$dayDate" || exit 1
sleep 1
if [ "`dgx xtdc d1 `" != "0" ] ; then
	echo "No dependence should be created"; exit 1
fi
dgx xdk d1 || exit 1
dgd rk ref || exit 1

################################################## circular reference for task
echo "test task dependence translation (onerror)" 

# t1 -(a)-> !t2! -(e)-> t3  : no dependence 
echo " step 1"
dgd ra ref || exit 1
dgd rta ref t1 || exit 1
dgd rtoa ref t1 add always || exit 1
dgd rta ref t2 || exit 1
dgd rta ref t3 || exit 1
dgd rtoa ref t3 add always || exit 1
dgd rtda ref t1 t2 always || exit 1
dgd rtda ref t2 t3 onerror || exit 1
dgd ese true || exit 1
dgd rp ref d1 "$dayDate" || exit 1
sleep 1
# verify that t3 is not selected
if [ "`dgx xtl d1 | grep t3`" != "" ] ; then
	echo "task t3 shouldn't be planned."; exit 1
fi
if [ "`dgx xtdc d1 `" != "0" ] ; then
	echo "No dependence should be created"; exit 1
fi
dgx xdk d1 || exit 1
dgd rk ref || exit 1

# t1 -(s)-> !t2! -(e)-> t3  : no dependence 
echo " step 2"
dgd ra ref || exit 1
dgd rta ref t1 || exit 1
dgd rtoa ref t1 add always || exit 1
dgd rta ref t2 || exit 1
dgd rta ref t3 || exit 1
dgd rtoa ref t3 add always || exit 1
dgd rtda ref t1 t2 onsuccess || exit 1
dgd rtda ref t2 t3 onerror || exit 1
dgd ese true || exit 1
dgd rp ref d1 "$dayDate" || exit 1
sleep 1
# verify that t3 is not selected
if [ "`dgx xtl d1 | grep t3`" != "" ] ; then
	echo "task t3 shouldn't be planned."; exit 1
fi
if [ "`dgx xtdc d1 `" != "0" ] ; then
	echo "No dependence should be created"; exit 1
fi
dgx xdk d1 || exit 1
dgd rk ref || exit 1

# t1 -(e)-> !t2! -(e)-> t3  : no dependence 
echo " step 3"
dgd ra ref || exit 1
dgd rta ref t1 || exit 1
dgd rtoa ref t1 add always || exit 1
dgd rta ref t2 || exit 1
dgd rta ref t3 || exit 1
dgd rtoa ref t3 add always || exit 1
dgd rtda ref t1 t2 onerror || exit 1
dgd rtda ref t2 t3 onerror || exit 1
dgd ese true || exit 1
dgd rp ref d1 "$dayDate" || exit 1
sleep 1
# verify that t3 is not selected
if [ "`dgx xtl d1 | grep t3`" != "" ] ; then
	echo "task t3 shouldn't be planned."; exit 1
fi
if [ "`dgx xtdc d1 `" != "0" ] ; then
	echo "No dependence should be created"; exit 1
fi
dgx xdk d1 || exit 1
dgd rk ref || exit 1

# verify memory
mem2=`dgd memory`
if [ $? != 0 ] ; then echo "error"; exit 1; fi
if [ $mem1 != $mem2 ] ; then
	echo "dg87d : memory error before and after rule $mem1 -> $mem2"
	exit 1
fi

echo "Stop dg87d"
stopDg87d || exit 1
echo "Stop dg87x"
stopDg87x || exit 1
