#!/bin/sh
#
# file tst22.sh 
# (test shiftAfter and shiftBefore operators)
#
#      Diogene87
#	Copyright (C) 2003 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" == "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Start dg87d"
startDg87d || exit 1

# dg87d : test 
mem1=`dgd memory`
if [ $? != 0 ] ; then echo "error"; exit 1; fi


################################################## circular reference for task
echo "test shift with day operation"

echo " shift after"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_week 5 || exit 1
dgd rroa ref r shift_after day "11-11" || exit 1
if [ "`dgd rrsr ref r \"2004-11-04\"`" != "Y" ] ; then
	echo "day is not selected."; exit 1
fi
if [ "`dgd rrsr ref r \"2004-11-05\" \"2004-11-11\" | grep N | wc -l`" -ne 7 ] ; then
	echo "wrong days are selected."; exit 1
fi
if [ "`dgd rrsr ref r \"2004-11-12\"`" != "Y" ] ; then
	echo "day is not selected."; exit 1
fi
if [ "`dgd rrsr ref r \"2004-11-13\" \"2004-11-17\" | grep N | wc -l`" -ne 5 ] ; then
	echo "wrong days are selected."; exit 1
fi
if [ "`dgd rrsr ref r \"2004-11-18\"`" != "Y" ] ; then
	echo "day is not selected."; exit 1
fi
dgd rk ref || exit 1

echo " shift before"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_week 5 || exit 1
dgd rroa ref r shift_before day "11-11" || exit 1
if [ "`dgd rrsr ref r \"2004-11-04\"`" != "Y" ] ; then
	echo "day is not selected."; exit 1
fi
if [ "`dgd rrsr ref r \"2004-11-05\" \"2004-11-09\" | grep N | wc -l`" -ne 5 ] ; then
	echo "wrong days are selected"; exit 1
fi
if [ "`dgd rrsr ref r \"2004-11-10\"`" != "Y" ] ; then
	echo "day is not selected."; exit 1
fi
if [ "`dgd rrsr ref r \"2004-11-11\" \"2004-11-17\" | grep N | wc -l`" -ne 7 ] ; then
	echo "wrong days are selected."; exit 1
fi
if [ "`dgd rrsr ref r \"2004-11-18\"`" != "Y" ] ; then
	echo "day is not selected."; exit 1
fi
dgd rk ref || exit 1

################################################## date
echo "test shift with date operation"

echo " shift after"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_month 11 || exit 1
dgd rroa ref r shift_after date "2004-11-11" || exit 1
for m in "2003-11" "2003-12" "2004-01" "2004-02" "2004-03" "2004-04" "2004-05" "2004-06" "2004-07" "2004-08" "2004-09" "2004-10" "2004-12" "2005-01" "2005-11"
do
	if [ "`dgd rrsr ref r \"$m-11\"`" != "Y" ] ; then
		echo "day is not selected ($m)."; exit 1
	fi
done
if [ "`dgd rrsr ref r \"2004-11-11\"`" != "N" ] ; then
	echo "day (11-11) is selected."; exit 1
fi
if [ "`dgd rrsr ref r \"2004-11-12\"`" != "Y" ] ; then
	echo "day (11-12) is not selected."; exit 1
fi
if [ "`dgd rrsr ref r \"2004-01-01\" \"2004-12-31\" | grep Y | wc -l`" -ne 12 ] ; then
	echo "12 days should be selected in year 2004."; exit 1
fi
dgd rk ref || exit 1

echo " shift before"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_month 11 || exit 1
dgd rroa ref r shift_before date "2004-11-11" || exit 1
for m in "2003-11" "2003-12" "2004-01" "2004-02" "2004-03" "2004-04" "2004-05" "2004-06" "2004-07" "2004-08" "2004-09" "2004-10" "2004-12" "2005-01" "2005-11"
do
	if [ "`dgd rrsr ref r \"$m-11\"`" != "Y" ] ; then
		echo "day is not selected ($m)."; exit 1
	fi
done
if [ "`dgd rrsr ref r \"2004-11-11\"`" != "N" ] ; then
	echo "day (11-11) is selected."; exit 1
fi
if [ "`dgd rrsr ref r \"2004-11-10\"`" != "Y" ] ; then
	echo "day (11-10) is not selected."; exit 1
fi
if [ "`dgd rrsr ref r \"2004-01-01\" \"2004-12-31\" | grep Y | wc -l`" -ne 12 ] ; then
	echo "12 days should be selected in year 2004."; exit 1
fi
dgd rk ref || exit 1


################################################## day_of_week 
echo "test shift with day_of_week operation"
echo " shift after"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_month 11 || exit 1
dgd rroa ref r shift_after day_of_week 1 || exit 1
for m in "2003-11" "2003-12" "2004-02" "2004-03" "2004-05" "2004-06" "2004-08" "2004-09" "2004-10" "2004-11" "2004-12" "2005-01" 
do
	if [ "`dgd rrsr ref r \"$m-11\"`" != "Y" ] ; then
		echo "day is not selected ($m-11)."; exit 1
	fi
done
for m in "2004-01" "2004-04" "2004-07" 
do
	if [ "`dgd rrsr ref r \"$m-12\"`" != "Y" ] ; then
		echo "day is not selected ($m-12)."; exit 1
	fi
done
if [ "`dgd rrsr ref r \"2004-01-01\" \"2004-12-31\" | grep Y | wc -l`" -ne 12 ] ; then
	echo "12 days should be selected in year 2004."; exit 1
fi
dgd rk ref || exit 1

echo " shift before"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_month 11 || exit 1
dgd rroa ref r shift_before day_of_week 1 || exit 1
for m in "2003-11" "2003-12" "2004-02" "2004-03" "2004-05" "2004-06" "2004-08" "2004-09" "2004-10" "2004-11" "2004-12" "2005-01" 
do
	if [ "`dgd rrsr ref r \"$m-11\"`" != "Y" ] ; then
		echo "day is not selected ($m-11)."; exit 1
	fi
done
for m in "2004-01" "2004-04" "2004-07" 
do
	if [ "`dgd rrsr ref r \"$m-10\"`" != "Y" ] ; then
		echo "day is not selected ($m-10)."; exit 1
	fi
done
if [ "`dgd rrsr ref r \"2004-01-01\" \"2004-12-31\" | grep Y | wc -l`" -ne 12 ] ; then
	echo "12 days should be selected in year 2004."; exit 1
fi
dgd rk ref || exit 1


################################################## day_of_month
echo "test shift with day_of_month operation"
echo " shift after"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_week 1 || exit 1
dgd rroa ref r shift_after day_of_month 11 || exit 1
for m in 01 02 03 04 05 06 07 08 09 10 11 12; do
	if [ "`dgd rrsr ref r \"2004-$m-11\"`" != "N" ] ; then
		echo "day is selected (2004-$m-11)."; exit 1
	fi
done
for m in "01-12" "04-12" "07-12" "09-12" "12-12"; do
	if [ "`dgd rrsr ref r \"2004-$m\"`" != "Y" ] ; then
		echo "day is not selected (2004-$m)."; exit 1
	fi
done
dgd rk ref || exit 1

echo " shift before"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_week 1 || exit 1
dgd rroa ref r shift_before day_of_month 11 || exit 1
for m in 01 02 03 04 05 06 07 08 09 10 11 12; do
	if [ "`dgd rrsr ref r \"2004-$m-11\"`" != "N" ] ; then
		echo "day is selected (2004-$m-11)."; exit 1
	fi
done
for m in "01-10" "04-10" "07-10" "09-12" "10-10" "12-12"; do
	if [ "`dgd rrsr ref r \"2004-$m\"`" != "Y" ] ; then
		echo "day is not selected (2004-$m)."; exit 1
	fi
done
dgd rk ref || exit 1


################################################## day_of_year
echo "test shift with day_of_year operation"

echo " shift after"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_week 5 || exit 1
dgd rroa ref r shift_after day_of_year 316 || exit 1
for m in "03-11" "02-12" "06-10" "08-12" "11-12"; do
	if [ "`dgd rrsr ref r \"2004-$m\"`" != "Y" ] ; then
		echo "day is not selected (2004-$m)."; exit 1
	fi
done
for m in "11-11" "11-10" "11-13" ; do
	if [ "`dgd rrsr ref r \"2004-$m\"`" != "N" ] ; then
		echo "day is selected (2004-$m)."; exit 1
	fi
done
dgd rk ref || exit 1

echo " shift before"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_week 5 || exit 1
dgd rroa ref r shift_before day_of_year 316 || exit 1
for m in "03-11" "02-12" "06-10" "08-12" "11-10"; do
	if [ "`dgd rrsr ref r \"2004-$m\"`" != "Y" ] ; then
		echo "day is not selected (2004-$m)."; exit 1
	fi
done
for m in "11-11" "11-12" "11-09" ; do
	if [ "`dgd rrsr ref r \"2004-$m\"`" != "N" ] ; then
		echo "day is selected (2004-$m)."; exit 1
	fi
done
dgd rk ref || exit 1


################################################## week_of_month
echo "test shift with week_of_month operation"
echo " shift after"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_week 5 || exit 1
dgd rroa ref r shift_after week_of_month 2 || exit 1

if [ "`dgd rrsr ref r \"2004-01-04\" \"2004-01-10\" | grep N | wc -l`" -ne 7 ]; then
	echo "a day is selected in week"; exit 1
fi
if [ "`dgd rrsr ref r \"2004-02-08\" \"2004-02-14\" | grep N | wc -l`" -ne 7 ]; then
	echo "a day is selected in week"; exit 1
fi
if [ "`dgd rrsr ref r \"2004-03-07\" \"2004-03-13\" | grep N | wc -l`" -ne 7 ]; then
	echo "a day is selected in week"; exit 1
fi
for m in "01-01" "01-11" "01-15" "01-22" "01-29" "02-05" "02-15" "02-19" "02-26" "03-04" "03-14"; do
	if [ "`dgd rrsr ref r \"2004-$m\"`" != "Y" ] ; then
		echo "day is not selected (2004-$m)."; exit 1
	fi
done
dgd rk ref || exit 1

echo " shift before"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_week 5 || exit 1
dgd rroa ref r shift_before week_of_month 2 || exit 1

if [ "`dgd rrsr ref r \"2004-01-04\" \"2004-01-10\" | grep N | wc -l`" -ne 7 ]; then
	echo "a day is selected in week"; exit 1
fi
if [ "`dgd rrsr ref r \"2004-02-08\" \"2004-02-14\" | grep N | wc -l`" -ne 7 ]; then
	echo "a day is selected in week"; exit 1
fi
if [ "`dgd rrsr ref r \"2004-03-07\" \"2004-03-13\" | grep N | wc -l`" -ne 7 ]; then
	echo "a day is selected in week"; exit 1
fi
for m in "01-01" "01-03" "01-15" "01-22" "01-29" "02-05" "02-07" "02-19" "02-26" "03-04" "03-06"; do
	if [ "`dgd rrsr ref r \"2004-$m\"`" != "Y" ] ; then
		echo "day is not selected (2004-$m)."; exit 1
	fi
done
dgd rk ref || exit 1


################################################## week_of_year
echo "test shift with week_of_year operation"
echo " shift after"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_week 5 || exit 1
dgd rroa ref r shift_after week_of_year 2 || exit 1
if [ "`dgd rrsr ref r \"2004-01-04\" \"2004-01-10\" | grep N | wc -l`" -ne 7 ]; then
	echo "a day is selected in week"; exit 1
fi
for m in "01-01" "01-11" "01-15" "01-22" "01-29" ; do
	if [ "`dgd rrsr ref r \"2004-$m\"`" != "Y" ] ; then
		echo "day is not selected (2004-$m)."; exit 1
	fi
done
dgd rk ref || exit 1

echo " shift before"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_week 5 || exit 1
dgd rroa ref r shift_before week_of_year 2 || exit 1
if [ "`dgd rrsr ref r \"2004-01-04\" \"2004-01-10\" | grep N | wc -l`" -ne 7 ]; then
	echo "a day is selected in week"; exit 1
fi
for m in "01-01" "01-03" "01-15" "01-22" "01-29" ; do
	if [ "`dgd rrsr ref r \"2004-$m\"`" != "Y" ] ; then
		echo "day is not selected (2004-$m)."; exit 1
	fi
done
dgd rk ref || exit 1

################################################## month_of_year
echo "test shift with month_of_year operation"
echo " shift after"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_month 5 || exit 1
dgd rroa ref r shift_after month_of_year 2 || exit 1
for m in "01-05" "03-01" "03-05" "04-05" "05-05" "06-05" "07-05" "08-05" "09-05" "10-05" "11-05" "12-05" ; do
	if [ "`dgd rrsr ref r \"2004-$m\"`" != "Y" ] ; then
		echo "day is not selected (2004-$m)."; exit 1
	fi
done
if [ "`dgd rrsr ref r \"2004-02-01\" \"2004-02-29\" | grep N | wc -l`" -ne 29 ]; then
	echo "Zero days should be selected in Febuary."; exit 1
fi
if [ "`dgd rrsr ref r \"2004-01-01\" \"2004-12-31\" | grep Y | wc -l`" -ne 12 ]; then
	echo "12 days should be selected in 2004."; exit 1
fi
dgd rk ref || exit 1

echo " shift before"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_month 5 || exit 1
dgd rroa ref r shift_before month_of_year 2 || exit 1
for m in "01-05" "01-31" "03-05" "04-05" "05-05" "06-05" "07-05" "08-05" "09-05" "10-05" "11-05" "12-05" ; do
	if [ "`dgd rrsr ref r \"2004-$m\"`" != "Y" ] ; then
		echo "day is not selected (2004-$m)."; exit 1
	fi
done
if [ "`dgd rrsr ref r \"2004-02-01\" \"2004-02-29\" | grep N | wc -l`" -ne 29 ]; then
	echo "Zero days should be selected in Febuary."; exit 1
fi
if [ "`dgd rrsr ref r \"2004-01-01\" \"2004-12-31\" | grep Y | wc -l`" -ne 12 ]; then
	echo "12 days should be selected in 2004."; exit 1
fi
dgd rk ref || exit 1


################################################## always
echo "test shift with always operation"
dgd ra ref || exit 1
dgd rra ref r || exit 1
dgd rroa ref r add day_of_month 5 || exit 1
# verify that we can't use 'skip_after always'
dgd rroa ref r shift_after always > /dev/null 2>&1
if [ $? -eq 0 ]; then
	echo "Can use 'always' operation whith 'skip_after'";exit 1
fi
if [ "`dgd rroc ref r`" -ne 1 ]; then
	echo "Operation count should be 1."; exit 1
fi
# verify that we can't use 'skip_before always'
dgd rroa ref r shift_before always > /dev/null 2>&1
if [ $? -eq 0 ]; then
	echo "Can use 'always' operation whith 'skip_before'";exit 1
fi
if [ "`dgd rroc ref r`" -ne 1 ]; then
	echo "Operation count should be 1."; exit 1
fi
dgd rk ref || exit 1

################################################## rule
echo "test shift with rule operation"
echo " shift after"
dgd ra ref || exit 1
dgd rra ref r1 || exit 1
dgd rroa ref r1 add month_of_year 5 || exit 1
dgd rroa ref r1 add month_of_year 7 || exit 1
dgd rra ref r2 || exit 1
dgd rroa ref r2 add day_of_month 5 || exit 1
dgd rroa ref r2 shift_after rule r1 || exit 1
for m in "01-05" "02-05" "03-05" "04-05" "06-05" "08-05" "09-05" "10-05" "11-05" "12-05" "06-01" "08-01" ; do
	if [ "`dgd rrsr ref r2 \"2004-$m\"`" != "Y" ] ; then
		echo "day is not selected (2004-$m)."; exit 1
	fi
done
if [ "`dgd rrsr ref r2 \"2004-05-01\" \"2004-05-31\" | grep N | wc -l`" -ne 31 ]; then
	echo "Zero days should be selected in May."; exit 1
fi
if [ "`dgd rrsr ref r2 \"2004-07-01\" \"2004-07-31\" | grep N | wc -l`" -ne 31 ]; then
	echo "Zero days should be selected in Jul."; exit 1
fi
if [ "`dgd rrsr ref r2 \"2004-01-01\" \"2004-12-31\" | grep Y | wc -l`" -ne 12 ]; then
	echo "12 days should be selected in 2004."; exit 1
fi
dgd rk ref || exit 1

echo " shift before"
dgd ra ref || exit 1
dgd rra ref r1 || exit 1
dgd rroa ref r1 add month_of_year 5 || exit 1
dgd rroa ref r1 add month_of_year 7 || exit 1
dgd rra ref r2 || exit 1
dgd rroa ref r2 add day_of_month 5 || exit 1
dgd rroa ref r2 shift_before rule r1 || exit 1
for m in "01-05" "02-05" "03-05" "04-05" "06-05" "08-05" "09-05" "10-05" "11-05" "12-05" "04-30" "06-30" ; do
	if [ "`dgd rrsr ref r2 \"2004-$m\"`" != "Y" ] ; then
		echo "day is not selected (2004-$m)."; exit 1
	fi
done
if [ "`dgd rrsr ref r2 \"2004-05-01\" \"2004-05-31\" | grep N | wc -l`" -ne 31 ]; then
	echo "Zero days should be selected in May."; exit 1
fi
if [ "`dgd rrsr ref r2 \"2004-07-01\" \"2004-07-31\" | grep N | wc -l`" -ne 31 ]; then
	echo "Zero days should be selected in Jul."; exit 1
fi
if [ "`dgd rrsr ref r2 \"2004-01-01\" \"2004-12-31\" | grep Y | wc -l`" -ne 12 ]; then
	echo "12 days should be selected in 2004."; exit 1
fi
dgd rk ref || exit 1



# verify memory
mem2=`dgd memory`
if [ $? != 0 ] ; then echo "error"; exit 1; fi
if [ $mem1 != $mem2 ] ; then
	echo "dg87d : memory error $mem1 -> $mem2"
	exit 1
fi

echo "Stop dg87d"
stopDg87d || exit 1
