#!/bin/sh
#
# file tst27.sh 
# (test variable for task planification)
#
#      Diogene87
#	Copyright (C) 2003 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" == "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Start dg87d"
startDg87d || exit 1
echo "Start dg87x"
startDg87x || exit 1

# memory 
memd1=`dgd memory` || exit 1
memx1=`dgx memory` || exit 1

dgd ese true || exit 1
dgx ese true || exit 1


################################################## 
echo "Test task operation"

dgd ra ref || exit 1

# add variables
for f in 1 2 3 4 ; do
	dgd va select_task$f || exit 1
done

# create tasks
dgd rta ref task1 || exit 1
dgd rtoa ref task1 add if_equal select_task1 YES || exit 1

dgd rta ref task2 || exit 1
dgd rtoa ref task2 add if_not_equal select_task2 NO || exit 1

dgd rta ref task3 || exit 1
dgd rtoa ref task3 add always || exit 1
dgd rtoa ref task3 remove if_equal select_task3 NO || exit 1

dgd rta ref task4 || exit 1
dgd rtoa ref task4 add always || exit 1
dgd rtoa ref task4 remove if_not_equal select_task4 YES || exit 1

# select all tasks
echo "  select all tasks"
for f in 1 2 3 4 ; do
	dgd vsv select_task$f YES || exit 1
done
dgd rp ref d1 "2004-03-19 00:00" || exit 1
sleep 1
for f in 1 2 3 4 ; do
	if [ "`dgx xtl d1 | grep task$f`" != "task$f" ]; then
		echo "Can't find task$f !"; exit 1
	fi
done
dgx xdk d1 || exit 1
# select no task
echo "  select no task"
for f in 1 2 3 4 ; do
	dgd vsv select_task$f NO  || exit 1
done
dgd rp ref d1 "2004-03-19 00:00" || exit 1
sleep 1
if [ "`dgx xtc d1`" != "0" ]; then
	echo "Task count is not 0 !"; exit 1
fi
dgx xdk d1 || exit 1

dgd rk ref || exit 1
for f in 1 2 3 4 ; do
	dgd vk select_task$f || exit 1
done

################################################## 
echo "Test rule operation"

dgd ra ref || exit 1

# add variables
for f in 1 2 3 4 ; do
	dgd va select_task$f || exit 1
done

# create tasks
dgd rra ref rule1 || exit 1
dgd rroa ref rule1 add if_equal select_task1 YES || exit 1
dgd rta ref task1 || exit 1
dgd rtoa ref task1 add rule rule1 || exit 1

dgd rra ref rule2 || exit 1
dgd rroa ref rule2 add if_not_equal select_task2 NO || exit 1
dgd rta ref task2 || exit 1
dgd rtoa ref task2 add rule rule1 || exit 1

dgd rra ref rule3 || exit 1
dgd rroa ref rule3 add always || exit 1
dgd rroa ref rule3 remove if_equal select_task3 NO || exit 1
dgd rta ref task3 || exit 1
dgd rtoa ref task3 add rule rule1 || exit 1

dgd rra ref rule4 || exit 1
dgd rroa ref rule3 add always || exit 1
dgd rroa ref rule4 remove if_not_equal select_task4 YES || exit 1
dgd rta ref task4 || exit 1
dgd rtoa ref task4 add rule rule1 || exit 1

# select all tasks
echo "  select all tasks"
for f in 1 2 3 4 ; do
	dgd vsv select_task$f YES || exit 1
done
dgd rp ref d1 "2004-03-19 00:00" || exit 1
sleep 1
for f in 1 2 3 4 ; do
	if [ "`dgx xtl d1 | grep task$f`" != "task$f" ]; then
		echo "Can't find task$f !"; exit 1
	fi
done
dgx xdk d1 || exit 1
# select no task
echo "  select no task"
for f in 1 2 3 4 ; do
	dgd vsv select_task$f NO  || exit 1
done
dgd rp ref d1 "2004-03-19 00:00" || exit 1
sleep 1
if [ "`dgx xtc d1`" != "0" ]; then
	echo "Task count is not 0 !"; exit 1
fi
dgx xdk d1 || exit 1

dgd rk ref || exit 1
for f in 1 2 3 4 ; do
	dgd vk select_task$f || exit 1
done


# verify memory
memd2=`dgd memory` || exit 1
if [ $memd1 != $memd2 ] ; then
	echo "dg87d : memory error $memd1 -> $memd2"; exit 1
fi
memx2=`dgx memory` || exit 1
if [ $memx1 != $memx2 ] ; then
	echo "dg87x : memory error $memx1 -> $memx2"; exit 1
fi

echo "Stop dg87d"
stopDg87d || exit 1
echo "Stop dg87x"
stopDg87x || exit 1
