#!/bin/sh
#
# file tst28.sh 
# (test variable replacement in path and argument)
#
#      Diogene87
#	Copyright (C) 2003 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" == "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Start dg87d"
startDg87d || exit 1
echo "Start dg87x"
startDg87x || exit 1
echo "Start dg87r"
startDg87r || exit 1

# memory 
memd1=`dgd memory` || exit 1
memx1=`dgx memory` || exit 1

dgd ese true || exit 1
dgx ese true || exit 1


################################################## 
echo "Test dg87d variable replacement"

dgd va var1 abc1cba || exit 1
dgd va var2 cde2edc || exit 1
dgd ra ref || exit 1
dgd rta ref tsk || exit 1
dgd rtoa ref tsk add always || exit 1

dgd rja ref tsk job1 || exit 1
dgd rjsp ref tsk job1 "$<var1>"
dgd rjsa ref tsk job1 "$<var1>"

dgd rja ref tsk job2 || exit 1
dgd rjsp ref tsk job2 "$<var1> $<var2>"
dgd rjsa ref tsk job2 "$<var1> $<var2>"

dgd rja ref tsk job3 || exit 1
dgd rjsp ref tsk job3 "$<xxx>"
dgd rjsa ref tsk job3 "$<xxx>"

dgd rja ref tsk job4 || exit 1
dgd rjsp ref tsk job4 "$<var1>$<xxx>"
dgd rjsa ref tsk job4 "$<var1>$<xxx>"

dgd rja ref tsk job5 || exit 1
dgd rjsp ref tsk job5 "xyz$<var1>zyx"
dgd rjsa ref tsk job5 "xyz$<var1>zyx"

dgd rja ref tsk job6 || exit 1
dgd rjsp ref tsk job6 "xyz$<var1>zyx$<var2>"
dgd rjsa ref tsk job6 "xyz$<var1>zyx$<var2>"

dgd rja ref tsk job7 || exit 1
dgd rjsp ref tsk job7 "$<>"
dgd rjsa ref tsk job7 "$<>"

dgd rja ref tsk job8 || exit 1
dgd rjsp ref tsk job8 "$<"
dgd rjsa ref tsk job8 "$<"

dgd rja ref tsk job9 || exit 1
dgd rjsp ref tsk job9 "$<xxx"
dgd rjsa ref tsk job9 "$<xxx"

dgd rp ref d1 "2004-03-22 00:00" || exit 1
sleep 1

# control job1
if [ "`dgx xji -S! d1 tsk job1 | grep Path`" != "Path!abc1cba" ]; then
	echo "Incorrect path for job1 !"; exit 1
fi
if [ "`dgx xji -S! d1 tsk job1 | grep Argument`" != "Argument!abc1cba" ]; then
	echo "Incorrect argument for job1 !"; exit 1
fi
# control job2
if [ "`dgx xji -S! d1 tsk job2 | grep Path`" != "Path!abc1cba cde2edc" ]; then
	echo "Incorrect path for job2 !"; exit 1
fi
if [ "`dgx xji -S! d1 tsk job2 | grep Argument`" != "Argument!abc1cba cde2edc" ]; then
	echo "Incorrect argument for job2 !"; exit 1
fi
# control job3
if [ "`dgx xji -S! d1 tsk job3 | grep Path`" != "Path!$<xxx>" ]; then
	echo "Incorrect path for job3 !"; exit 1
fi
if [ "`dgx xji -S! d1 tsk job3 | grep Argument`" != "Argument!$<xxx>" ]; then
	echo "Incorrect argument for job3 !"; exit 1
fi
# control job4
if [ "`dgx xji -S! d1 tsk job4 | grep Path`" != "Path!abc1cba$<xxx>" ]; then
	echo "Incorrect path for job4 !"; exit 1
fi
if [ "`dgx xji -S! d1 tsk job4 | grep Argument`" != "Argument!abc1cba$<xxx>" ]; then
	echo "Incorrect argument for job4 !"; exit 1
fi
# control job5 "xyz$<var1>zyx"
if [ "`dgx xji -S! d1 tsk job5 | grep Path`" != "Path!xyzabc1cbazyx" ]; then
	echo "Incorrect path for job5 !"; exit 1
fi
if [ "`dgx xji -S! d1 tsk job5 | grep Argument`" != "Argument!xyzabc1cbazyx" ]; then
	echo "Incorrect argument for job5 !"; exit 1
fi
# control job6 "xyz$<var1>zyx"
if [ "`dgx xji -S! d1 tsk job6 | grep Path`" != "Path!xyzabc1cbazyxcde2edc" ]; then
	echo "Incorrect path for job6 !"; exit 1
fi
if [ "`dgx xji -S! d1 tsk job6 | grep Argument`" != "Argument!xyzabc1cbazyxcde2edc" ]; then
	echo "Incorrect argument for job6 !"; exit 1
fi
# control job7 "$<>"
if [ "`dgx xji -S! d1 tsk job7 | grep Path`" != "Path!$<>" ]; then
	echo "Incorrect path for job7 !"; exit 1
fi
if [ "`dgx xji -S! d1 tsk job7 | grep Argument`" != "Argument!$<>" ]; then
	echo "Incorrect argument for job7 !"; exit 1
fi

# control job8 "$<"
if [ "`dgx xji -S! d1 tsk job8 | grep Path`" != "Path!$<" ]; then
	echo "Incorrect path for job8 !"; exit 1
fi
if [ "`dgx xji -S! d1 tsk job8 | grep Argument`" != "Argument!$<" ]; then
	echo "Incorrect argument for job8 !"; exit 1
fi
# control job9 "$<xxx"
if [ "`dgx xji -S! d1 tsk job9 | grep Path`" != "Path!$<xxx" ]; then
	echo "Incorrect path for job9 !"; exit 1
fi
if [ "`dgx xji -S! d1 tsk job9 | grep Argument`" != "Argument!$<xxx" ]; then
	echo "Incorrect argument for job9 !"; exit 1
fi
dgd rk ref || exit 1
dgd vk var1 || exit 1
dgd vk var2 || exit 1
dgx xdk d1 || exit 1

################################################## 
echo "Test dg87x variable replacement"

dgx va var1 "c_c" || exit 1
dgx va var2 "job10.sh" || exit 1
dgd ta localhost || exit 1
dgd qa localhost batch || exit 1
dgx ta localhost || exit 1
dgx tso localhost true || exit 1
dgx qa localhost batch || exit 1
dgx qso localhost batch true || exit 1

dgd ra ref || exit 1
dgd rta ref task_1 || exit 1
dgd rtoa ref task_1 add always || exit 1
dgd rtsq ref task_1 localhost batch || exit 1

dgd rja ref task_1 job_1 || exit 1
dgd rjsp ref task_1 job_1 "$JOBPATH/$<var2>"
dgd rjsa ref task_1 job_1 "ab$<var1>ba"

dgd rp ref day_1 "$dayDate" || exit 1
sleep 1
dgx xdse day_1 true || exit 1
sleep 1

# interpret exit code
res="`dgx xji day_1 task_1 job_1 | grep Exit | awk '{print $3}'`"


if [ $res -eq 1 ]; then
	echo "incorrect value for DG87_DAY environment variable !"; exit 1
fi
if [ $res -eq 2 ]; then
	echo "incorrect value for DG87_TASK environment variable !"; exit 1
fi
if [ $res -eq 3 ]; then
	echo "incorrect value for DG87_JOB environment variable !"; exit 1
fi
if [ $res -eq 4 ]; then
	echo "incorrect value for argument !"; exit 1
fi

if [ $res -ne 0 ]; then
	echo "Job exit code isn't zero !"; exit 1
fi

if [ "`dgx xjl -sS! day_1 task_1`" != "job_1!terminated" ]; then
	echo "Job isn't terminated !" ; exit 1
fi

dgd rk ref || exit 1

dgd tk localhost || exit 1
dgx tk localhost || exit 1
dgx xdk day_1 || exit 1
dgx vk var1 || exit 1
dgx vk var2 || exit 1

# verify memory
memd2=`dgd memory` || exit 1
if [ $memd1 != $memd2 ] ; then
	echo "dg87d : memory error $memd1 -> $memd2"; exit 1
fi
memx2=`dgx memory` || exit 1
if [ $memx1 != $memx2 ] ; then
	echo "dg87x : memory error $memx1 -> $memx2"; exit 1
fi

echo "Stop dg87d"
stopDg87d || exit 1
echo "Stop dg87x"
stopDg87x || exit 1
echo "Stop dg87r"
stopDg87r || exit 1
