#!/bin/sh
#
# file tst29.sh 
# (test long hostname for targets)
#
#      Diogene87
#	Copyright (C) 2003 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" == "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Start dg87d"
startDg87d || exit 1
echo "Start dg87x"
startDg87x || exit 1
echo "Start dg87r"
startDg87r || exit 1

# memory 
memd1=`dgd memory` || exit 1
memx1=`dgx memory` || exit 1

dgd ese true || exit 1
dgx ese true || exit 1

################################################## 
echo "Test dg87d target hostname"

dgd ta my_computer || exit 1
dgd tsh my_computer localhost
if [ $? -ne 0 ]; then
	echo "Can't set long hostname for target"; exit 1
fi
if [ "`dgd ti my_computer | grep "Host Name" | awk '{print $3}'`" != "localhost" ]; then
	echo "Long hostname for target is not set"; exit 1
fi
dgd tsh my_computer "" 
if [ $? -ne 0 ]; then
	echo "Can't erase long hostname for target"; exit 1
fi
if [ "`dgd ti my_computer | grep "Host Name" | awk '{print $3}'`" != "" ]; then
	echo "Long hostname for target is not erased"; exit 1
fi
dgd tk my_computer || exit 1

################################################## 
echo "Test dg87x target hostname"

dgx ta my_computer || exit 1
dgx tsh my_computer localhost
if [ $? -ne 0 ]; then
	echo "Can't set long hostname for target"; exit 1
fi
if [ "`dgx ti my_computer | grep "Host Name" | awk '{print $3}'`" != "localhost" ]; then
	echo "Long hostname for target is not set"; exit 1
fi
dgx tsh my_computer "" 
if [ $? -ne 0 ]; then
	echo "Can't erase long hostname for target"; exit 1
fi
if [ "`dgx ti my_computer | grep "Host Name" | awk '{print $3}'`" != "" ]; then
	echo "Long hostname for target is not erased"; exit 1
fi
dgx tk my_computer || exit 1


################################################## 
echo "Test dg87r communication with target hostname"

dgd ta my_computer || exit 1
dgd tsh my_computer localhost || exit 1
dgd qa my_computer batch || exit 1

dgx ta my_computer || exit 1
dgx tsh my_computer localhost || exit 1
dgx tso my_computer true || exit 1
dgx qa my_computer batch || exit 1
dgx qso my_computer batch true || exit 1

dgd ra ref || exit 1
dgd rta ref tsk || exit 1
dgd rtoa ref tsk add always || exit 1
dgd rtsq ref tsk my_computer batch || exit 1

dgd rja ref tsk job || exit 1
dgd rjsp ref tsk job "$JOBPATH/job4.sh" || exit 1

dgd rp ref day1 "$dayDate" || exit 1
sleep 1
dgx xdse day1 true || exit 1
sleep 1
if [ "`dgx xjl day1 tsk -sS!`" != "job!running" ]; then
	echo "Job is not running !"; exit 1
fi
sleep 2
if [ "`dgx xjl day1 tsk -sS!`" != "job!terminated" ]; then
	echo "Job is not terminated !"; exit 1
fi

dgd rk ref || exit 1
dgd tk my_computer || exit 1
dgx xdk day1 || exit 1
dgx tk my_computer || exit 1

# verify memory
memd2=`dgd memory` || exit 1
if [ $memd1 != $memd2 ] ; then
	echo "dg87d : memory error $memd1 -> $memd2"; exit 1
fi
memx2=`dgx memory` || exit 1
if [ $memx1 != $memx2 ] ; then
	echo "dg87x : memory error $memx1 -> $memx2"; exit 1
fi

echo "Stop dg87d"
stopDg87d || exit 1
echo "Stop dg87x"
stopDg87x || exit 1
echo "Stop dg87r"
stopDg87r || exit 1
