#!/bin/sh
#
# file tst31.sh 
# (test DIOGENE_PASSWORD)
#
#      Diogene87
#	Copyright (C) 2003 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" == "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

DIOGENE_PASSWORD=ad_77x+k
tmpconffiled=`mktemp /tmp/dg87.XXXXXX`
tmpconffilex=`mktemp /tmp/dg87.XXXXXX`
tmpconffiler=`mktemp /tmp/dg87.XXXXXX`

trap "rm $tmpconffiled $tmpconffilex $tmpconffiler  2>/dev/null" SIGINT

# create configuration file
cat > $tmpconffiled <<EOF
IPPORT=9998
DG87X_ADDRESS=localhost
DG87X_IPPORT=9996
DIOGENE_PASSWORD=$DIOGENE_PASSWORD
EOF
cat > $tmpconffilex <<EOF
IPPORT=9996
DIOGENE_PASSWORD=$DIOGENE_PASSWORD
EOF
cat > $tmpconffiler <<EOF
IPPORT=9997
DG87X_ADDRESS=localhost
DG87X_IPPORT=9996
DIOGENE_PASSWORD=$DIOGENE_PASSWORD
EOF

# start daemon
echo "start dg87d"
$PathDg87d -dNC $tmpconffiled
sleep 1
echo "start dg87x"
$PathDg87x -dNC $tmpconffilex
sleep 1
echo "start dg87r"
$PathDg87r -dNC $tmpconffiler
sleep 1

# test communication
$PathDgd -- version >/dev/null || exit 1
$PathDgx -- version >/dev/null || exit 1
$PathDgr -- version >/dev/null || exit 1

# test diogene password
$PathDgd -u diogene -p $DIOGENE_PASSWORD -- version >/dev/null 
if [ $? -ne 0 ]; then 
	echo "Can't communicate with dg87d with diogene account"; exit 1
fi
$PathDgx -u diogene -p $DIOGENE_PASSWORD -- version >/dev/null
if [ $? -ne 0 ]; then 
	echo "Can't communicate with dg87x with diogene account"; exit 1
fi
$PathDgr -u diogene -p $DIOGENE_PASSWORD -- version >/dev/null
if [ $? -ne 0 ]; then 
	echo "Can't communicate with dg87r with diogene account"; exit 1
fi

# test daemons communication
echo "test daemons communication with a new password for diogene account"
dgd ese true || exit 1
dgd ta localhost || exit 1
dgd qa localhost batch || exit 1

dgx ese true || exit 1
dgx ta localhost || exit 1
dgx tso localhost true || exit 1
dgx qa localhost batch || exit 1
dgx qso localhost batch true || exit 1

dgd ra r1 || exit 1
dgd rta r1 t1 || exit 1
dgd rtoa r1 t1 add always || exit 1
dgd rtsq r1 t1 localhost batch || exit 1
dgd rja r1 t1 j1 || exit 1
dgd rjsp r1 t1 j1 "$JOBPATH/job1.sh"

dgd rp r1 d1 "$dayDate" || exit 1
sleep 1
if [ "`dgx xdl`" != "d1" ]; then
	echo "Day 'd1' is not created ! Communication problem between dg87d and dg87x"; exit 1
fi

dgx xdse d1 true || exit 1
sleep 2
if [ "`dgx xji d1 t1 j1 | grep State | awk '{print $2}'`" != "terminated" ]; 
then
	echo "Job isn't terminated. Communication problem between dg87x and dg87r"; exit 1
fi
if [ "`dgx xti d1 t1 | grep State | awk '{print $2}'`" != "terminated" ]; then
	echo "Task isn't terminated."; exit 1
fi
dgd rk r1 || exit 1
dgd tk localhost || exit 1
dgx xdk d1 || exit 1
dgx tk localhost || exit 1

echo "stop dg87d"
$PathDgd -- shutdown > /dev/null || exit 1
echo "stop dg87x"
$PathDgx -- shutdown > /dev/null || exit 1
echo "stop dg87r"
$PathDgr -- shutdown > /dev/null || exit 1

rm $tmpconffiled $tmpconffilex $tmpconffiler  2>/dev/null

exit 0
