#!/bin/sh
#
# file tst32.sh 
# (test job scheduling with dg87r stopped)
#
#      Diogene87
#	Copyright (C) 2003 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" == "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Start dg87d"
startDg87d || exit 1
echo "Start dg87x"
startDg87x || exit 1

dgd ese true || exit 1
dgx ese true || exit 1

################################################## 
echo "Test job scheduling with dg87r stopped"

dgd ta localhost || exit 1
dgd qa localhost batch || exit 1

dgx ta localhost || exit 1
dgx tso localhost true || exit 1
dgx qa localhost batch || exit 1
dgx qso localhost batch true || exit 1

dgd ra ref || exit 1
dgd rta ref tsk || exit 1
dgd rtoa ref tsk add always || exit 1
dgd rtsq ref tsk localhost batch || exit 1

dgd rja ref tsk job || exit 1
dgd rjsp ref tsk job "$JOBPATH/job4.sh" || exit 1

dgd rp ref day1 "$dayDate" || exit 1
sleep 1
dgx xdse day1 true || exit 1
sleep 1
if [ "`dgx xjl day1 tsk -sS!`" != "job!submit" ]; then
	echo "Job is not submited !"; exit 1
fi

echo "Start dg87r"
startDg87r || exit 1
dgx ese true || exit 1

echo -n "Wait connection retry (<20s)"
n=0
while [ $n -le 20 ] ; do 
	n=$(( $n + 1 )) 
	sleep 1
	echo -n "."
	if [ "`dgx xjl day1 tsk -sS!`" == "job!running" ]; then
		echo -e "\nJob is running."
		break
	fi
done
if [ $n -ge 20 ]; then
	echo -e "\nTimeout ! Job is not running !"; exit 1
fi
echo "Wait job is terminated"
sleep 3 
if [ "`dgx xjl day1 tsk -sS!`" != "job!terminated" ]; then
	echo "Job is not terminated !"; exit 1
fi

dgd rk ref || exit 1
dgd tk localhost || exit 1
dgx xdk day1 || exit 1
dgx tk localhost || exit 1

echo "Stop dg87d"
stopDg87d || exit 1
echo "Stop dg87x"
stopDg87x || exit 1
echo "Stop dg87r"
stopDg87r || exit 1
