#!/bin/sh
#
# file tst33.sh 
# (test dg87d save)
#
#      Diogene87
#	Copyright (C) 2003 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" == "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Start dg87d"
startDg87d || exit 1

echo " create database"

# variables
dgd va vr1 value1 || exit 1
dgd va vr2 || exit 1
dgd va vr3 || exit 1

# targets
dgd ta tg1 "target_1" || exit 1 
dgd tsh tg1 "www.tg1.com"
dgd tsp tg1 8888
dgd ta tg2 "target_2" || exit 1

# queues
dgd qa tg1 q1 "queue_1" || exit 1
dgd qsm tg1 q1 99 || exit 1
dgd qa tg1 q2 "queue_2" || exit 1
dgd qa tg2 q3 || exit 1
dgd qa tg2 q4 || exit 1
dgd qa tg2 q5 || exit 1

# referentials
dgd ra ref1 || exit 1
dgd ra ref2 || exit 1
dgd ra ref3 || exit 1

# tasks 
dgd rta ref1 tsk1 "task_1" || exit 1
dgd rta ref1 tsk2 || exit 1
dgd rta ref2 tsk3 || exit 1
dgd rta ref2 tsk4 || exit 1
dgd rta ref3 tsk5 || exit 1
dgd rtswad ref1 tsk1 true || exit 1
dgd rtswad ref1 tsk2 false || exit 1
dgd rtsoec ref1 tsk1 true || exit 1
dgd rtsoec ref1 tsk2 false || exit 1
dgd rtsq ref1 tsk1 tg1 q1 || exit 1

# jobs
dgd rja ref1 tsk1 job1 "job_1" || exit 1
dgd rja ref1 tsk1 job2 || exit 1
dgd rja ref1 tsk1 job3 || exit 1
dgd rja ref2 tsk3 job4 || exit 1
dgd rja ref2 tsk3 job5 || exit 1

dgd rjsp ref1 tsk1 job1 "/bin/ls" || exit 1
dgd rjsa ref1 tsk1 job1 "args" || exit 1
dgd rjst ref1 tsk1 job1 33 36 || exit 1
dgd rjswad ref1 tsk1 job1 true || exit 1
dgd rjswad ref1 tsk1 job2 false || exit 1
dgd rjsoec ref1 tsk1 job1 true || exit 1
dgd rjsoec ref1 tsk1 job2 false || exit 1

# job dependances 
dgd rjda ref1 tsk1 job1 job2 always || exit 1
dgd rjda ref1 tsk1 job1 job3 onerror || exit 1
dgd rjda ref1 tsk1 job2 job3 onsuccess || exit 1
dgd rjda ref2 tsk3 job4 job5 || exit 1

# task dependances 
dgd rta ref3 t1 || exit 1
dgd rta ref3 t2 || exit 1
dgd rta ref3 t3 || exit 1
dgd rta ref3 t4 || exit 1
dgd rtda ref3 t1 t2 always || exit 1
dgd rtda ref3 t1 t3 onerror || exit 1
dgd rtda ref3 t1 t4 onsuccess || exit 1

# task conditions
dgd rtca ref1 tsk1 hmin "08:05" || exit 1
dgd rtca ref1 tsk1 hmax "09:05" || exit 1
dgd rtca ref1 tsk1 hlate "10:05" || exit 1
dgd rtca ref1 tsk1 file "/tmp/top" || exit 1
dgd rtca ref1 tsk1 manual "OK" || exit 1
dgd rtca ref1 tsk1 if_equal vr1 YES  || exit 1
dgd rtca ref1 tsk1 if_not_equal vr2 NO  || exit 1

# rules
dgd rra ref1 rul1 || exit 1
dgd rroa ref1 rul1 add day_of_week 3 || exit 1
dgd rroa ref1 rul1 add day_of_month 4 || exit 1
dgd rroa ref1 rul1 add week_of_month 5 || exit 1
dgd rroa ref1 rul1 add month_of_year 6 || exit 1
dgd rroa ref1 rul1 add day "07-08" || exit 1
dgd rroa ref1 rul1 add date "2004-09-10" || exit 1
dgd rroa ref1 rul1 add always || exit 1
dgd rroa ref1 rul1 add if_equal vr1 OK || exit 1
dgd rroa ref1 rul1 add if_not_equal vr2 NO || exit 1

dgd rra ref1 rul2 || exit 1
dgd rroa ref1 rul2 add day_of_week 2|| exit 1
dgd rroa ref1 rul2 addfrom day_of_week 3 || exit 1
dgd rroa ref1 rul2 adduntil day_of_week 4 || exit 1

dgd rra ref1 rul3 || exit 1
dgd rroa ref1 rul3 remove day_of_week 2|| exit 1
dgd rroa ref1 rul3 removefrom day_of_week 3 || exit 1
dgd rroa ref1 rul3 removeuntil day_of_week 4 || exit 1

dgd rra ref1 rul4 || exit 1
dgd rroa ref1 rul4 shift_after day_of_week 2|| exit 1
dgd rroa ref1 rul4 shift_before day_of_week 3|| exit 1

dgd rra ref1 rul5 || exit 1
dgd rroa ref1 rul5 add rule rul1 || exit 1

# task operations 
dgd rtoa ref1 tsk1 add day_of_week 3 || exit 1
dgd rtoa ref1 tsk1 add day_of_month 4 || exit 1
dgd rtoa ref1 tsk1 add week_of_month 5 || exit 1
dgd rtoa ref1 tsk1 add month_of_year 6 || exit 1
dgd rtoa ref1 tsk1 add day "07-08" || exit 1
dgd rtoa ref1 tsk1 add date "2004-09-10" || exit 1
dgd rtoa ref1 tsk1 add always || exit 1
dgd rtoa ref1 tsk1 add if_equal vr1 OK || exit 1
dgd rtoa ref1 tsk1 add if_not_equal vr2 NO || exit 1

dgd rtoa ref1 tsk2 add day_of_week 2|| exit 1
dgd rtoa ref1 tsk2 addfrom day_of_week 3 || exit 1
dgd rtoa ref1 tsk2 adduntil day_of_week 4 || exit 1

dgd rtoa ref2 tsk3 remove day_of_week 2|| exit 1
dgd rtoa ref2 tsk3 removefrom day_of_week 3 || exit 1
dgd rtoa ref2 tsk3 removeuntil day_of_week 4 || exit 1

dgd rtoa ref2 tsk4 shift_after day_of_week 2|| exit 1
dgd rtoa ref2 tsk4 shift_before day_of_week 3|| exit 1

dgd rra ref3 rul1 || exit 1
dgd rtoa ref3 tsk5 add rule rul1 || exit 1

# users
for f in generic communication user engine target referential job day variable ;
do
	dgd ua user_$f
	dgd usp user_$f none generic communication user engine target referential job day variable ;
	dgd usp user_$f admin $f
done

echo "Restart dg87d"
stopDg87d
sleep 1
$PathDg87d -C $buildpath/$srcdir/dg87d.conf -d
sleep 1

# verify targets
echo " verify targets"
if [ "`dgd tc`" != 2 ]; then
	echo "Can't find two targets !"; exit 1
fi
if [ "`dgd tl | grep tg1`" != "tg1" ] ; then
	echo "Can't find target_1 !"; exit 1
fi
if [ "`dgd tl | grep tg2`" != "tg2" ] ; then
	echo "Can't find target_2 !"; exit 1
fi
if [ "`dgd ti -S! tg1 | grep Description`" != "Description!target_1" ] ; then
	echo "Incorrect target description !"; exit 1
fi
if [ "`dgd ti -S! tg1 | grep "Host Name"`" != "Host Name!www.tg1.com" ] ; then
	echo "Incorrect target host name!"; exit 1
fi
if [ "`dgd ti -S! tg1 | grep "IP Port"`" != "IP Port!8888" ] ; then
	echo "Incorrect target IP Port!"; exit 1
fi

# verify queues
echo " verify queues"
if [ "`dgd qc tg1`" != 2 ]; then
	echo "Can't find two queues in target tg1 !"; exit 1
fi
if [ "`dgd qc tg2`" != 3 ]; then
	echo "Can't find three queues in target tg2 !"; exit 1
fi
if [ "`dgd ql tg1 | grep q1`" != "q1" ] ; then
	echo "Can't find queue 'q1' in target_1 !"; exit 1
fi
if [ "`dgd ql tg1 | grep q2`" != "q2" ] ; then
	echo "Can't find queue 'q2' in target_1 !"; exit 1
fi
if [ "`dgd qi -S! tg1 q1 | grep Description`" != "Description!queue_1" ] ; then
	echo "Incorrect queue description !"; exit 1
fi
if [ "`dgd qi -S! tg1 q1 | grep Max`" != "Max!99" ] ; then
	echo "Incorrect queue max running job!"; exit 1
fi

# verify variables 
echo " verify variables"
if [ "`dgd vc`" != 3 ]; then
	echo "Can't find three variables !"; exit 1
fi
for f in vr1 vr2 vr3 ; do
	if [ "`dgd vl | grep $f`" != "$f" ] ; then
		echo "Can't find variable '$f' !"; exit 1
	fi
done
if [ "`dgd vi -S! vr1 | grep Value`" != "Value!value1" ] ; then
	echo "Incorrect variable value !"; exit 1
fi

# verify users 
echo " verify users"
if [ "`dgd uc`" -ne 11 ] ; then
	echo "Can't find 11 users !"; exit 1
fi
for f in generic communication user engine target referential job day variable ;
do
	if [ "`dgd ul | grep user_$f | wc -l`" -ne "1" ]; then
		echo "Can't find user 'user_$f' !"; exit 1
	fi
	# all privileges are 'none' except one
	if [ "`dgd ui user_$f | grep none | wc -l`" -ne "8" ]; then
		echo "Can't find 8 privileges to 'none'"; exit 1
	fi
	if [ "`dgd ui -S_ user_$f | grep ${f}_admin | wc -l`" -ne "1" ]; then
		echo "privileges '$f' is not set to 'admin'"; exit 1
	fi
done

# verify referentials
echo " verify referentials"
if [ "`dgd rc`" != 3 ]; then
	echo "Can't find three referentials !"; exit 1
fi
for f in ref1 ref2 ref3 ; do
	if [ "`dgd rl | grep $f`" != "$f" ] ; then
		echo "Can't find referential '$f' !"; exit 1
	fi
done

# verify tasks 
echo " verify tasks"
if [ "`dgd rtc ref1`" != 2 ]; then
	echo "Can't find two tasks in ref1!"; exit 1
fi
for f in tsk1 tsk2 ; do
	if [ "`dgd rtl ref1 | grep $f`" != "$f" ] ; then
		echo "Can't find tasks '$f' in ref1 !"; exit 1
	fi
done
if [ "`dgd rtc ref2`" != 2 ]; then
	echo "Can't find two tasks in ref2!"; exit 1
fi
for f in tsk3 tsk4 ; do
	if [ "`dgd rtl ref2 | grep $f`" != "$f" ] ; then
		echo "Can't find tasks '$f' in ref2 !"; exit 1
	fi
done
if [ "`dgd rtc ref3`" != 5 ]; then
	echo "Can't find one tasks in ref3!"; exit 1
fi
# verify task properties
if [ "`dgd rti -S! ref1 tsk1 | grep Description`" != "Description!task_1" ] ; then
	echo "Incorrect task description !"; exit 1
fi
# verify "wait all dependences"
if [ "`dgd rti -S! ref1 tsk1 | grep "Wait All Dependences"`" != "Wait All Dependences!true" ] ; then
	echo "Incorrect 'Wait All Dependences' for tsk1 !"; exit 1
fi
if [ "`dgd rti -S! ref1 tsk2 | grep "Wait All Dependences"`" != "Wait All Dependences!false" ] ; then
	echo "Incorrect 'Wait All Dependences' for tsk2 !"; exit 1
fi
# verify "on error continue"
if [ "`dgd rti -S! ref1 tsk1 | grep "On Error Continue"`" != "On Error Continue!true" ] ; then
	echo "Incorrect 'On Error Continue' for tsk1 !"; exit 1
fi
if [ "`dgd rti -S! ref1 tsk2 | grep "On Error Continue"`" != "On Error Continue!false" ] ; then
	echo "Incorrect 'On Error Continue' for tsk2 !"; exit 1
fi
# verify target and queue 
if [ "`dgd rti -S! ref1 tsk1 | grep Target`" != "Target!tg1" ] ; then
	echo "Incorrect target for tsk1 !"; exit 1
fi
if [ "`dgd rti -S! ref1 tsk2 | grep Target`" != "Target!none" ] ; then
	echo "Incorrect target for tsk2 !"; exit 1
fi
if [ "`dgd rti -S! ref1 tsk1 | grep Queue`" != "Queue!q1" ] ; then
	echo "Incorrect queue for tsk1 !"; exit 1
fi
if [ "`dgd rti -S! ref1 tsk2 | grep Queue`" != "Queue!none" ] ; then
	echo "Incorrect queue for tsk2 !"; exit 1
fi

# verify jobs 
echo " verify jobs"
if [ "`dgd rjc ref1 tsk1`" != 3 ]; then
	echo "Can't find three jobs in tsk1 in ref1!"; exit 1
fi
for f in job1 job2 job3 ; do
	if [ "`dgd rjl ref1 tsk1 | grep $f`" != "$f" ] ; then
		echo "Can't find job '$f' in tsk1 in ref1 !"; exit 1
	fi
done
if [ "`dgd rjc ref2 tsk3`" != 2 ]; then
	echo "Can't find two jobs in tsk3 in ref2!"; exit 1
fi
for f in job4 job5 ; do
	if [ "`dgd rjl ref2 tsk3 | grep $f`" != "$f" ] ; then
		echo "Can't find job '$f' in tsk3 in ref2 !"; exit 1
	fi
done

# verify job properties
if [ "`dgd rji -S! ref1 tsk1 job1 | grep Description`" != "Description!job_1" ] ; then
	echo "Incorrect job description !"; exit 1
fi
if [ "`dgd rji -S! ref1 tsk1 job1 | grep Path`" != "Path!/bin/ls" ] ; then
	echo "Incorrect job path !"; exit 1
fi
if [ "`dgd rji -S! ref1 tsk1 job1 | grep Argument`" != "Argument!args" ] ; then
	echo "Incorrect job argument !"; exit 1
fi
if [ "`dgd rji -S! ref1 tsk1 job1 | grep "Start Tempo"`" != "Start Tempo!33" ] ; then
	echo "Incorrect job start tempo!"; exit 1
fi
if [ "`dgd rji -S! ref1 tsk1 job1 | grep "End Tempo"`" != "End Tempo!36" ] ; then
	echo "Incorrect job start tempo!"; exit 1
fi
if [ "`dgd rji -S! ref1 tsk1 job1 | grep "Wait All Dependences"`" != "Wait All Dependences!true" ] ; then
	echo "Incorrect 'wait all dependences' for job1 !"; exit 1
fi
if [ "`dgd rji -S! ref1 tsk1 job2 | grep "Wait All Dependences"`" != "Wait All Dependences!false" ] ; then
	echo "Incorrect 'wait all dependences' for job2 !"; exit 1
fi
if [ "`dgd rji -S! ref1 tsk1 job1 | grep "On Error Continue"`" != "On Error Continue!true" ] ; then
	echo "Incorrect 'on error continue' for job1 !"; exit 1
fi
if [ "`dgd rji -S! ref1 tsk1 job2 | grep "On Error Continue"`" != "On Error Continue!false" ] ; then
	echo "Incorrect 'on error continue' for job2 !"; exit 1
fi

# verify jobs dependances
echo " verify jobs dependances"
if [ "`dgd rjdc ref1 tsk1`" != 3 ]; then
	echo "Can't find three jobs dependances in tsk1 in ref1!"; exit 1
fi
if [ "`dgd rjdc ref2 tsk3`" != 1 ]; then
	echo "Can't find one jobs dependance in tsk3 in ref2!"; exit 1
fi
if [ "`dgd rjdl -tS_ ref1 tsk1 | grep job1_job2_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'always' job dependance  !"; exit 1
fi
if [ "`dgd rjdl -tS_ ref1 tsk1 | grep job1_job3_onerror | wc -l`" -ne "1" ] ; then
	echo "Can't find 'onerror' job dependance  !"; exit 1
fi
if [ "`dgd rjdl -tS_ ref1 tsk1 | grep job2_job3_onsuccess | wc -l`" -ne "1" ] ; then
	echo "Can't find 'onsuccess' job dependance  !"; exit 1
fi

# verify tasks dependances
echo " verify tasks dependances"
if [ "`dgd rtdc ref3`" != 3 ]; then
	echo "Can't find three tasks dependances in ref3!"; exit 1
fi
if [ "`dgd rtdl -tS_ ref3 | grep t1_t2_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'always' task dependance  !"; exit 1
fi
if [ "`dgd rtdl -tS_ ref3 | grep t1_t3_onerror | wc -l`" -ne "1" ] ; then
	echo "Can't find 'onerror' task dependance  !"; exit 1
fi
if [ "`dgd rtdl -tS_ ref3 | grep t1_t4_onsuccess | wc -l`" -ne "1" ] ; then
	echo "Can't find 'onsuccess' task dependance  !"; exit 1
fi

# verify rules
echo " verify rules"
if [ "`dgd rrc ref1`" -ne 5 ] ; then
	echo "Can't find 4 rules in ref1 !"; exit 1
fi
for f in rul1 rul2 rul3 rul4 rul5 ; do
	if [ "`dgd rrl ref1 | grep $f | wc -l`" -ne "1" ]; then
		echo "Can't find rule '$f' !"; exit 1
	fi
done

# verify rul1
if [ "`dgd rrol -S_ ref1 rul1 | grep add_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day_of_week' rule operation !"; exit 1
fi
if [ "`dgd rrol -S_ ref1 rul1 | grep add_day_of_month_4 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day_of_month' rule operation !"; exit 1
fi
if [ "`dgd rrol -S_ ref1 rul1 | grep add_week_of_month_5 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add week_of_month' rule operation !"; exit 1
fi
if [ "`dgd rrol -S_ ref1 rul1 | grep add_month_of_year_6 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add month_of_year' rule operation !"; exit 1
fi
if [ "`dgd rrol -S_ ref1 rul1 | grep "add_day_09-06" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day' rule operation !"; exit 1
fi
if [ "`dgd rrol -S_ ref1 rul1 | grep "add_date_2004-09-10" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add date' rule operation !"; exit 1
fi
if [ "`dgd rrol -S_ ref1 rul1 | grep add_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add always' rule operation !"; exit 1
fi
if [ "`dgd rrol -S_ ref1 rul1 | grep add_if_equal_vr1_OK | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add if_equal' rule operation !"; exit 1
fi
if [ "`dgd rrol -S_ ref1 rul1 | grep add_if_not_equal_vr2_NO | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add if_not_equal' rule operation !"; exit 1
fi

#verify rul2
if [ "`dgd rrol -S_ ref1 rul2 | grep add_day_of_week_2 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day_of_week' rule operation !"; exit 1
fi
if [ "`dgd rrol -S_ ref1 rul2 | grep addfrom_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'addfrom day_of_week' rule operation !"; exit 1
fi
if [ "`dgd rrol -S_ ref1 rul2 | grep adduntil_day_of_week_4 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'adduntil day_of_week' rule operation !"; exit 1
fi

#verify rul3
if [ "`dgd rrol -S_ ref1 rul3 | grep remove_day_of_week_2 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'remove day_of_week' rule operation !"; exit 1
fi
if [ "`dgd rrol -S_ ref1 rul3 | grep removefrom_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'removefrom day_of_week' rule operation !"; exit 1
fi
if [ "`dgd rrol -S_ ref1 rul3 | grep removeuntil_day_of_week_4 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'removeuntil day_of_week' rule operation !"; exit 1
fi

#verify rul4
if [ "`dgd rrol -S_ ref1 rul4 | grep shift_after_day_of_week_2 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'shift_after day_of_week' rule operation !"; exit 1
fi
if [ "`dgd rrol -S_ ref1 rul4 | grep shift_before_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'shift_before day_of_week' rule operation !"; exit 1
fi

#verify rul5
if [ "`dgd rrol -S_ ref1 rul5 | grep add_rule_rul1 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add rule' rule operation !"; exit 1
fi

# verify tasks rules
echo " verify task operations"
# verify tsk1
if [ "`dgd rtol -S_ ref1 tsk1 | grep add_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day_of_week' task operation !"; exit 1
fi
if [ "`dgd rtol -S_ ref1 tsk1 | grep add_day_of_month_4 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day_of_month' task operation !"; exit 1
fi
if [ "`dgd rtol -S_ ref1 tsk1 | grep add_week_of_month_5 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add week_of_month' task operation !"; exit 1
fi
if [ "`dgd rtol -S_ ref1 tsk1 | grep add_month_of_year_6 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add month_of_year' task operation !"; exit 1
fi
if [ "`dgd rtol -S_ ref1 tsk1 | grep "add_day_09-06" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day' task operation !"; exit 1
fi
if [ "`dgd rtol -S_ ref1 tsk1 | grep "add_date_2004-09-10" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add date' task operation !"; exit 1
fi
if [ "`dgd rtol -S_ ref1 tsk1 | grep add_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add always' task operation !"; exit 1
fi
if [ "`dgd rtol -S_ ref1 tsk1 | grep add_if_equal_vr1_OK | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add if_equal' task operation !"; exit 1
fi
if [ "`dgd rtol -S_ ref1 tsk1 | grep add_if_not_equal_vr2_NO | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add if_not_equal' taskoperation !"; exit 1
fi

#verify tsk2
if [ "`dgd rtol -S_ ref1 tsk2 | grep add_day_of_week_2 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day_of_week' task operation !"; exit 1
fi
if [ "`dgd rtol -S_ ref1 tsk2 | grep addfrom_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'addfrom day_of_week' task operation !"; exit 1
fi
if [ "`dgd rtol -S_ ref1 tsk2 | grep adduntil_day_of_week_4 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'adduntil day_of_week' task operation !"; exit 1
fi

#verify tsk3
if [ "`dgd rtol -S_ ref2 tsk3 | grep remove_day_of_week_2 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'remove day_of_week' task operation !"; exit 1
fi
if [ "`dgd rtol -S_ ref2 tsk3 | grep removefrom_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'removefrom day_of_week' task operation !"; exit 1
fi
if [ "`dgd rtol -S_ ref2 tsk3 | grep removeuntil_day_of_week_4 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'removeuntil day_of_week' task operation !"; exit 1
fi

#verify tsk4
if [ "`dgd rtol -S_ ref2 tsk4 | grep shift_after_day_of_week_2 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'shift_after day_of_week' task operation !"; exit 1
fi
if [ "`dgd rtol -S_ ref2 tsk4 | grep shift_before_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'shift_before day_of_week' task operation !"; exit 1
fi

if [ "`dgd rtol -S_ ref3 tsk5 | grep add_rule_rul1 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add rule' task operation !"; exit 1
fi

# verify conditions
echo " verify tasks conditions"
if [ "`dgd rtcl -S_ ref1 tsk1 | grep "hmin_08:05" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hmin' task condition !"; exit 1
fi
if [ "`dgd rtcl -S_ ref1 tsk1 | grep "hmax_09:05" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hmax' task condition !"; exit 1
fi
if [ "`dgd rtcl -S_ ref1 tsk1 | grep "hlate_10:05" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hlate' task condition !"; exit 1
fi
if [ "`dgd rtcl -S_ ref1 tsk1 | grep "file_/tmp/top" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'file' task condition !"; exit 1
fi
if [ "`dgd rtcl -S_ ref1 tsk1 | grep "manual_OK" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'manual' task condition !"; exit 1
fi
if [ "`dgd rtcl -S_ ref1 tsk1 | grep "if_equal_vr1_YES" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'if_equal' task condition !"; exit 1
fi
if [ "`dgd rtcl -S_ ref1 tsk1 | grep "if_not_equal_vr2_NO" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'if_not_equal' task condition !"; exit 1
fi


echo "Stop dg87d"
stopDg87d || exit 1
