#!/bin/sh
#
# file tst34.sh 
# (test dg87x save)
#
#      Diogene87
#	Copyright (C) 2003 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" == "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Start dg87d"
startDg87d || exit 1
echo "Start dg87x"
startDg87x || exit 1

echo " create database"

# variables
dgd va vr1 value1 || exit 1
dgd va vr2 || exit 1
dgd va vr3 || exit 1
dgx va vr1 value1 || exit 1
dgx va vr2 || exit 1
dgx va vr3 || exit 1

# targets
dgd ta tg1 "target_1" || exit 1 
dgd tsh tg1 "www.tg1.com"
dgd tsp tg1 8888
dgd ta tg2 "target_2" || exit 1

dgx ta tg1 "target_1" || exit 1 
dgx tsh tg1 "www.tg1.com"
dgx tsp tg1 8888
dgx ta tg2 "target_2" || exit 1

# queues
dgd qa tg1 q1 "queue_1" || exit 1
dgd qsm tg1 q1 99 || exit 1
dgd qa tg1 q2 "queue_2" || exit 1
dgd qa tg2 q3 || exit 1
dgd qa tg2 q4 || exit 1
dgd qa tg2 q5 || exit 1

dgx qa tg1 q1 "queue_1" || exit 1
dgx qsm tg1 q1 99 || exit 1
dgx qa tg1 q2 "queue_2" || exit 1
dgx qa tg2 q3 || exit 1
dgx qa tg2 q4 || exit 1
dgx qa tg2 q5 || exit 1

# users
for f in generic communication user engine target referential job day variable ;
do
	dgx ua user_$f || exit 1
	dgx usp user_$f none generic communication user engine target referential job day variable || exit 1
	dgx usp user_$f admin $f || exit 1
done

# referential
dgd ra ref_1 || exit 1
dgd ra ref_2 || exit 1

# tasks
dgd rta ref_1 task_1 "tsk1" || exit 1
dgd rtoa ref_1 task_1 add always || exit 1
dgd rta ref_1 task_2 || exit 1
dgd rtoa ref_1 task_2 add always || exit 1
dgd rta ref_1 task_3 || exit 1
dgd rtoa ref_1 task_3 add always || exit 1
dgd rta ref_1 task_4 || exit 1
dgd rtoa ref_1 task_4 add always || exit 1
dgd rta ref_1 task_5 || exit 1
dgd rtoa ref_1 task_5 add always || exit 1

dgd rta ref_2 task_6 || exit 1
dgd rtoa ref_2 task_6 add always || exit 1
dgd rta ref_2 task_7 || exit 1
dgd rtoa ref_2 task_7 add always || exit 1

dgd rtswad ref_1 task_1 true || exit 1
dgd rtswad ref_1 task_2 false || exit 1
dgd rtsoec ref_1 task_1 true || exit 1
dgd rtsoec ref_1 task_2 false || exit 1
dgd rtsq ref_1 task_1 tg1 q1 || exit 1

# tasks conditions
dgd rtca ref_1 task_5 hmin "08:05" || exit 1
dgd rtca ref_1 task_5 hmax "09:05" || exit 1
dgd rtca ref_1 task_5 hlate "10:05" || exit 1
dgd rtca ref_1 task_5 file "/tmp/top" || exit 1
dgd rtca ref_1 task_5 manual "OK" || exit 1
dgd rtca ref_1 task_5 if_equal vr1 YES  || exit 1
dgd rtca ref_1 task_5 if_not_equal vr2 NO  || exit 1

# tasks dependences
dgd rtda ref_1 task_1 task_2 always || exit 1
dgd rtda ref_1 task_1 task_3 onerror || exit 1
dgd rtda ref_1 task_2 task_4 onsuccess || exit 1
dgd rtda ref_2 task_6 task_7 always || exit 1

# jobs
dgd rja ref_1 task_1 job_1 "job1" || exit 1
dgd rja ref_1 task_1 job_2 || exit 1
dgd rja ref_1 task_1 job_3 || exit 1
dgd rja ref_1 task_1 job_4 || exit 1
dgd rja ref_1 task_1 job_5 || exit 1
dgd rja ref_1 task_2 job_6 || exit 1
dgd rja ref_1 task_2 job_7 || exit 1

dgd rjsp ref_1 task_1 job_1 "/bin/ls" || exit 1
dgd rjsa ref_1 task_1 job_1 "args" || exit 1
dgd rjst ref_1 task_1 job_1 33 36 || exit 1
dgd rjswad ref_1 task_1 job_1 true || exit 1
dgd rjswad ref_1 task_1 job_2 false || exit 1
dgd rjsoec ref_1 task_1 job_1 true || exit 1
dgd rjsoec ref_1 task_1 job_2 false || exit 1

# jobs dependences
dgd rjda ref_1 task_1 job_1 job_2 always || exit 1
dgd rjda ref_1 task_1 job_2 job_3 onsuccess || exit 1
dgd rjda ref_1 task_1 job_3 job_4 onerror || exit 1
dgd rjda ref_1 task_2 job_6 job_7 always || exit 1

# create new days
echo " create new days"
dgd ese true || exit 1
dgx ese false || exit 1
dgd rp ref_1 day_1 "$dayDate" || exit 1
sleep 2
dgd rp ref_2 day_2 "$dayDate" || exit 1
sleep 2
dgx xdse day_1 false || exit 1
dgx xdse day_2 true || exit 1

# change task state
dgx xtu day_1 task_1 terminated || exit 1
dgx xtu day_1 task_2 aborted || exit 1
# change job state
dgx xju day_1 task_1 job_1 terminated || exit 1
dgx xju day_1 task_1 job_2 aborted 23 || exit 1
# change condition state
dgx xtcv day_1 task_5 1

echo "Stop dg87d"
stopDg87d || exit 1

echo "Restart dg87x"
stopDg87x
sleep 1
$PathDg87x -C $buildpath/$srcdir/dg87x.conf -d
sleep 1

# verify targets
echo " verify targets"
if [ "`dgx tc`" != 2 ]; then
	echo "Can't find two targets !"; exit 1
fi
if [ "`dgx tl | grep tg1`" != "tg1" ] ; then
	echo "Can't find target_1 !"; exit 1
fi
if [ "`dgx tl | grep tg2`" != "tg2" ] ; then
	echo "Can't find target_2 !"; exit 1
fi
if [ "`dgx ti -S! tg1 | grep Description`" != "Description!target_1" ] ; then
	echo "Incorrect target description !"; exit 1
fi
if [ "`dgx ti -S! tg1 | grep "Host Name"`" != "Host Name!www.tg1.com" ] ; then
	echo "Incorrect target host name!"; exit 1
fi
if [ "`dgx ti -S! tg1 | grep "IP Port"`" != "IP Port!8888" ] ; then
	echo "Incorrect target IP Port!"; exit 1
fi

# verify queues
echo " verify queues"
if [ "`dgx qc tg1`" != 2 ]; then
	echo "Can't find two queues in target tg1 !"; exit 1
fi
if [ "`dgx qc tg2`" != 3 ]; then
	echo "Can't find three queues in target tg2 !"; exit 1
fi
if [ "`dgx ql tg1 | grep q1`" != "q1" ] ; then
	echo "Can't find queue 'q1' in target_1 !"; exit 1
fi
if [ "`dgx ql tg1 | grep q2`" != "q2" ] ; then
	echo "Can't find queue 'q2' in target_1 !"; exit 1
fi
if [ "`dgx qi -S! tg1 q1 | grep Description`" != "Description!queue_1" ] ; then
	echo "Incorrect queue description !"; exit 1
fi
if [ "`dgx qi -S! tg1 q1 | grep Max`" != "Max!99" ] ; then
	echo "Incorrect queue max running job!"; exit 1
fi

# verify variables 
echo " verify variables"
if [ "`dgx vc`" != 3 ]; then
	echo "Can't find three variables !"; exit 1
fi
for f in vr1 vr2 vr3 ; do
	if [ "`dgx vl | grep $f`" != "$f" ] ; then
		echo "Can't find variable '$f' !"; exit 1
	fi
done
if [ "`dgx vi -S! vr1 | grep Value`" != "Value!value1" ] ; then
	echo "Incorrect variable value !"; exit 1
fi

# verify users 
echo " verify users"
if [ "`dgx uc`" -ne 11 ] ; then
	echo "Can't find 11 users !"; exit 1
fi
for f in generic communication user engine target referential job day variable ;
do
	if [ "`dgx ul | grep user_$f | wc -l`" -ne "1" ]; then
		echo "Can't find user 'user_$f' !"; exit 1
	fi
	# all privileges are 'none' except one
	if [ "`dgx ui user_$f | grep none | wc -l`" -ne "8" ]; then
		echo "Can't find 8 privileges to 'none'"; exit 1
	fi
	if [ "`dgx ui -S_ user_$f | grep ${f}_admin | wc -l`" -ne "1" ]; then
		echo "privileges '$f' is not set to 'admin'"; exit 1
	fi
done

# verify days 
echo " verify days"
if [ "`dgx xdc`" != 2 ]; then
	echo "Can't find 2 days !"; exit 1
fi
for f in day_1 day_2 ; do
	if [ "`dgx xdl | grep $f`" != "$f" ] ; then
		echo "Can't find day '$f' !"; exit 1
	fi
done
if [ "`dgx xdi -S_ day_1 | grep \"Start Time_$dayDate\" | wc -l`" -ne "1" ]; then
	echo "Incorrect date for day_1"; exit 1
fi
if [ "`dgx xdi -S_ day_1 | grep \"Enabled_false\" | wc -l`" -ne "1" ]; then
	echo "day_1 is not disabled"; exit 1
fi
if [ "`dgx xdi -S_ day_2 | grep \"Enabled_true\" | wc -l`" -ne "1" ]; then
	echo "day_2 is not enabled"; exit 1
fi

# verify tasks 
echo " verify tasks"
if [ "`dgx xtc day_1`" != 5 ]; then
	echo "Can't find 5 tasks in day_1 !"; exit 1
fi
for f in task_1 task_2 task_3 task_4 task_5 ; do
	if [ "`dgx xtl day_1 | grep $f`" != "$f" ] ; then
		echo "Can't find task '$f' in day_1 !"; exit 1
	fi
done
if [ "`dgx xtc day_2`" != 2 ]; then
	echo "Can't find 2 tasks in day_2 !"; exit 1
fi
for f in task_6 task_7 ; do
	if [ "`dgx xtl day_2 | grep $f`" != "$f" ] ; then
		echo "Can't find task '$f' in day_2 !"; exit 1
	fi
done

# verify task properties
if [ "`dgx xti -S! day_1 task_1 | grep Description`" != "Description!tsk1" ] ; then
	echo "Incorrect task description !"; exit 1
fi
if [ "`dgx xti -S_ day_1 task_1 | grep State`" != "State_terminated" ] ; then
	echo "Incorrect state for task_1 !"; exit 1
fi
if [ "`dgx xti -S_ day_1 task_2 | grep State`" != "State_aborted" ] ; then
	echo "Incorrect state for task_2 !"; exit 1
fi
if [ "`dgx xti -S_ day_1 task_3 | grep State`" != "State_uninitialize" ] ; then
	echo "Incorrect state for task_3 !"; exit 1
fi

# verify "wait all dependences"
if [ "`dgx xti -S! day_1 task_1 | grep "Wait All Dependences"`" != "Wait All Dependences!true" ] ; then
	echo "Incorrect 'Wait All Dependences' for task_1 !"; exit 1
fi
if [ "`dgx xti -S! day_1 task_2 | grep "Wait All Dependences"`" != "Wait All Dependences!false" ] ; then
	echo "Incorrect 'Wait All Dependences' for task_2 !"; exit 1
fi
# verify "on error continue"
if [ "`dgx xti -S! day_1 task_1 | grep "On Error Continue"`" != "On Error Continue!true" ] ; then
	echo "Incorrect 'On Error Continue' for tsk1 !"; exit 1
fi
if [ "`dgx xti -S! day_1 task_2 | grep "On Error Continue"`" != "On Error Continue!false" ] ; then
	echo "Incorrect 'On Error Continue' for tsk2 !"; exit 1
fi
# verify target and queue 
if [ "`dgx xti -S! day_1 task_1 | grep Target`" != "Target!tg1" ] ; then
	echo "Incorrect target for task_1 !"; exit 1
fi
if [ "`dgx xti -S! day_1 task_2 | grep Target`" != "Target!none" ] ; then
	echo "Incorrect target for task_2 !"; exit 1
fi
if [ "`dgx xti -S! day_1 task_1 | grep Queue`" != "Queue!q1" ] ; then
	echo "Incorrect queue for task_1 !"; exit 1
fi
if [ "`dgx xti -S! day_1 task_2 | grep Queue`" != "Queue!none" ] ; then
	echo "Incorrect queue for task_2 !"; exit 1
fi


# verify tasks conditions
echo " verify tasks conditions"
if [ "`dgx xtcc day_1 task_5`" != 7 ]; then
	echo "Can't find 7 tasks dependences in task_5 of day_1 !"; exit 1
fi
if [ "`dgx xtcl -S_ day_1 task_5 | grep \"hmin_08:05\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hmin' condition in task_5 of day_1"; exit 1
fi
if [ "`dgx xtcl -S_ day_1 task_5 | grep \"hmax_09:05\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hmax' condition in task_5 of day_1"; exit 1
fi
if [ "`dgx xtcl -S_ day_1 task_5 | grep \"hlate_10:05\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hlate' condition in task_5 of day_1"; exit 1
fi
if [ "`dgx xtcl -S_ day_1 task_5 | grep \"file_/tmp/top\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'file' condition in task_5 of day_1"; exit 1
fi
if [ "`dgx xtcl -S_ day_1 task_5 | grep \"manual_OK\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'manual' condition in task_5 of day_1"; exit 1
fi
if [ "`dgx xtcl -S_ day_1 task_5 | grep \"if_equal_vr1_YES\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'if_equal' condition in task_5 of day_1"; exit 1
fi
if [ "`dgx xtcl -S_ day_1 task_5 | grep \"if_not_equal_vr2_NO\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'if_not_equal' condition in task_5 of day_1"; exit 1
fi
# verify condition state
if [ "`dgx xtcl day_1 task_5 -sS_ | grep \"hmin_08:05_finished\" | wc -l `" -ne "1" ] ; then
	echo "First task conditions is not finished"; exit 1
fi
if [ "`dgx xtcl day_1 task_5 -sS_ | grep \"hmax_09:05_waiting\" | wc -l `" -ne "1" ] ; then
	echo "Second task conditions is not finished"; exit 1
fi

# verify tasks dependences
echo " verify tasks dependences"
if [ "`dgx xtdc day_1`" != 3 ]; then
	echo "Can't find 3 tasks dependences in day_1 !"; exit 1
fi
if [ "`dgx xtdl -tS_ day_1 | grep task_1_task_2_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'always' dependence in day_1"; exit 1
fi
if [ "`dgx xtdl -tS_ day_1 | grep task_1_task_3_onerror| wc -l`" -ne "1" ] ; then
	echo "Can't find 'onerror' dependence in day_1"; exit 1
fi
if [ "`dgx xtdl -tS_ day_1 | grep task_2_task_4_onsuccess | wc -l`" -ne "1" ] ; then
	echo "Can't find 'onsuccess' dependence in day_1"; exit 1
fi
if [ "`dgx xtdc day_2`" != 1 ]; then
	echo "Can't find 1 tasks dependences in day_2 !"; exit 1
fi
if [ "`dgx xtdl -tS_ day_2 | grep task_6_task_7_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'always' dependence in day_2"; exit 1
fi

# verify dependence state
if [ "`dgx xtdl -sS_ day_1 | grep task_1_task_2_validated | wc -l`" -ne "1" ] ; then
	echo "Dependence between task_1 and task_2 isn't validated"; exit 1
fi
if [ "`dgx xtdl -sS_ day_1 | grep task_1_task_3_canceled | wc -l`" -ne "1" ] ; then
	echo "Dependence between task_1 and task_3 isn't canceled"; exit 1
fi

# verify jobs 
echo " verify jobs"
if [ "`dgx xjc day_1 task_1`" != 5 ]; then
	echo "Can't find 5 jobs in task_1 of day_1 !"; exit 1
fi
for f in job_1 job_2 job_3 job_4 job_5 ; do
	if [ "`dgx xjl day_1 task_1 | grep $f`" != "$f" ] ; then
		echo "Can't find job '$f' in task_1 of day_1 !"; exit 1
	fi
done
if [ "`dgx xjc day_1 task_2`" != 2 ]; then
	echo "Can't find 2 jobs in task_2 of day_1 !"; exit 1
fi
for f in job_6 job_7 ; do
	if [ "`dgx xjl day_1 task_2 | grep $f`" != "$f" ] ; then
		echo "Can't find job '$f' in task_2 of day_1 !"; exit 1
	fi
done
# verify job properties
if [ "`dgx xji -S! day_1 task_1 job_1 | grep Description`" != "Description!job1" ] ; then
	echo "Incorrect job description !"; exit 1
fi
if [ "`dgx xji -S! day_1 task_1 job_1 | grep Path`" != "Path!/bin/ls" ] ; then
	echo "Incorrect job path !"; exit 1
fi
if [ "`dgx xji -S! day_1 task_1 job_1 | grep Argument`" != "Argument!args" ] ; then
	echo "Incorrect job argument !"; exit 1
fi
if [ "`dgx xji -S! day_1 task_1 job_1 | grep "Start Tempo"`" != "Start Tempo!33" ] ; then
	echo "Incorrect job start tempo!"; exit 1
fi
if [ "`dgx xji -S! day_1 task_1 job_1 | grep "End Tempo"`" != "End Tempo!36" ] ; then
	echo "Incorrect job start tempo!"; exit 1
fi
if [ "`dgx xji -S! day_1 task_1 job_1 | grep "Wait All Dependences"`" != "Wait All Dependences!true" ] ; then
	echo "Incorrect 'wait all dependences' for job_1 !"; exit 1
fi
if [ "`dgx xji -S! day_1 task_1 job_2 | grep "Wait All Dependences"`" != "Wait All Dependences!false" ] ; then
	echo "Incorrect 'wait all dependences' for job_2 !"; exit 1
fi
if [ "`dgx xji -S! day_1 task_1 job_1 | grep "On Error Continue"`" != "On Error Continue!true" ] ; then
	echo "Incorrect 'on error continue' for job_1 !"; exit 1
fi
if [ "`dgx xji -S! day_1 task_1 job_2 | grep "On Error Continue"`" != "On Error Continue!false" ] ; then
	echo "Incorrect 'on error continue' for job_2 !"; exit 1
fi

if [ "`dgx xji -S_ day_1 task_1 job_1 | grep State`" != "State_terminated" ] ; then
	echo "Incorrect state for job_1 !"; exit 1
fi
if [ "`dgx xji -S_ day_1 task_1 job_2 | grep State`" != "State_aborted" ] ; then
	echo "Incorrect state for job_2 !"; exit 1
fi
if [ "`dgx xji -S_ day_1 task_1 job_2 | grep \"Exit code_23\" | wc -l `" -ne "1" ] ; then
	echo "Incorrect exit code for job_2 !"; exit 1
fi

# verify jobs dependences
echo " verify jobs dependences"
if [ "`dgx xjdc day_1 task_1`" != 3 ]; then
	echo "Can't find 3 jobs dependences in task_1 of day_1 !"; exit 1
fi
if [ "`dgx xjdl -tS_ day_1 task_1 | grep job_1_job_2_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'always' dependence in task_1 of day_1"; exit 1
fi
if [ "`dgx xjdl -tS_ day_1 task_1 | grep job_2_job_3_onsuccess | wc -l`" -ne "1" ] ; then
	echo "Can't find 'onsuccess' dependence in task_1 of day_1"; exit 1
fi
if [ "`dgx xjdl -tS_ day_1 task_1 | grep job_3_job_4_onerror | wc -l`" -ne "1" ] ; then
	echo "Can't find 'onerror' dependence in task_1 of day_1"; exit 1
fi
if [ "`dgx xjdc day_1 task_2`" != 1 ]; then
	echo "Can't find 1 jobs dependences in task_2 of day_1 !"; exit 1
fi
if [ "`dgx xjdl -tS_ day_1 task_2 | grep job_6_job_7_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'always' dependence in task_2 of day_1"; exit 1
fi


echo "Stop dg87x"
stopDg87x || exit 1
