/* file cmdtask.h */
/*
 *      Diogene87
 *	Copyright (C) 2003-2004 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef CMDREFTASK_H
#define CMDREFTASK_H 1

#include "global.h"
#include <libdg87/element.h>
#include "task.h"
#include "ref.h"
#include "config.h"
#include "cmdoperation.h"
#include <libdg87/connection.h>

/* commands for TASK */
int cmd_rtk(dg87_connection* pConnection);
int cmd_rta(dg87_connection* pConnection);
int cmd_rtc(dg87_connection* pConnection);
int cmd_rtl(dg87_connection* pConnection);
int cmd_rti(dg87_connection* pConnection);
int cmd_rtsr(dg87_connection* pConnection);
int cmd_rtsy(dg87_connection* pConnection);

/* rtsq : change the queue of an TASK */
int cmd_rtsq(dg87_connection* pConnection);
/* rtsd : change the description of an TASK */
int cmd_rtsd(dg87_connection* pConnection);
/* rtswot : change WaitOldestTask for a task */
int cmd_rtswot(dg87_connection* pConnection);
/* rtswad : change WaitAllDependences for a task */
int cmd_rtswad(dg87_connection* pConnection);
/* rtsoec : change OnErrorContinue for a task */
int cmd_rtsoec(dg87_connection* pConnection);

/* commands for TASK dep */
int cmd_rtdl(dg87_connection* pConnection);
int cmd_rtdc(dg87_connection* pConnection);
int cmd_rtda(dg87_connection* pConnection);
int cmd_rtdk(dg87_connection* pConnection);

/* commands for TASK condition */
int cmd_rtcl(dg87_connection* pConnection);
int cmd_rtcc(dg87_connection* pConnection);
int cmd_rtca(dg87_connection* pConnection);
int cmd_rtck(dg87_connection* pConnection);

/* commands for operations */
int cmd_rtok(dg87_connection* pConnection);
int cmd_rtoa(dg87_connection* pConnection);
int cmd_rtoc(dg87_connection* pConnection);
int cmd_rtol(dg87_connection* pConnection);
int cmd_rtom(dg87_connection* pConnection);

#endif /*CMDREFTASK_H*/

/* End of file */
