/* file caller.c */
/*
 *      Diogene87
 *	Copyright (C) 2003-2004 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#include "context.h"
#include "caller.h"
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <config.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include "../libdg87/daemon.h"

/******************************************************************************/
BOOL dg87_caller_transmitState(dg87_context* pContext, dg87_job* pJob)
{
	char* pBuffer;
	int size;
 
	if (pContext == NULL || pJob == NULL){
		dg87_err_setError(DG87_ERR_NULLPARAMETER);
		return FALSE;
	}
	/*xju "DayName" "TaskName" "JobName" "State" "[exitCode]"*/
	size = strlen(pJob->dayName) + strlen(pJob->taskName) +
		strlen(pJob->jobName) + 
		strlen(dg87_job_stateToAscii(pJob->state)) + 50;
	pBuffer = dg87_malloc(size, DG87_CHAR);
	if (pBuffer == NULL){
		dg87_err_setError(DG87_ERR_OUTOFMEMORY);
		return FALSE;
	}
	snprintf(pBuffer, size ,"xju \"%s\" \"%s\" \"%s\" \"%s\" \"%i\"",
		       pJob->dayName, pJob->taskName,pJob->jobName,
		       dg87_job_stateToAscii(pJob->state),
		       pJob->status);
	
	if (dg87_server_postMessage(pContext->pServer, 
		pContext->dg87x_address, 
		pContext->dg87x_ipPort, pBuffer) == FALSE)
	{
		dg87_free(pBuffer, DG87_CHAR);
		return FALSE;
	}


	dg87_free(pBuffer, DG87_CHAR);
	return TRUE;
}
/******************************************************************************/

/* End of file */
