/* file engine.h */
/*
 *      Diogene87
 *	Copyright (C) 2003-2004 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef ENGINE_H
#define ENGINE_H 1

#include "global.h"
#include "context.h"

typedef struct dg87_engine_struct
{
	dg87_context* pContext;
} dg87_engine;

/*
 * dg87_engine_new
 */
dg87_engine* dg87_engine_new(dg87_context* pContext);

/*
 * dg87_engine_delete
 */
BOOL dg87_engine_delete(dg87_engine* pEngine);


/*
 * dg87_engine_run
 * This function is call by dg87_server.
 */
BOOL dg87_engine_run(dg87_engine* pEngine, dg87_server* pServer);

#ifdef DEBUG
/*
 * dg87_engine_ckeck
 */
int dg87_engine_check(dg87_engine* pEngine, int (*print)(char*));
#endif /*DEBUG*/

#endif /*ENGINE_H*/
/* End of file */
