/* file util.c */
/*
 *      Diogene87
 *	Copyright (C) 2003-2004 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#include "util.h"
#include <string.h>
#include <libdg87/item.h>
#include <context.h>

/******************************************************************************/
dg87_job* dg87_util_findJob(dg87_connection *pConnec, 
		char* pDayName, char* pTaskName, char* pJobName)
{
	dg87_job* pJob = NULL;
	dg87_item* pItem;
	dg87_context* pContext;
	if (pConnec == NULL || pTaskName == NULL 
			|| pJobName == NULL || pDayName == NULL){
		dg87_err_setError(DG87_ERR_NULLPARAMETER);
		return NULL;
	}
	dg87_err_clearError();
	pContext = pConnec->pServer->pData;
	pItem = pContext->pJobList->pFirst;
	while (pItem != NULL){
		pJob = pItem->pObject;
		if (strcmp(pJob->taskName, pTaskName) == 0 &&
				strcmp(pJob->jobName, pJobName) == 0 &&
				strcmp(pJob->dayName, pDayName) == 0)
			return pJob;
		pItem = pItem->pNext;
	}

	/* we don't find the job */
	dg87_connection_printf(pConnec,
		"Can't find the job '%s' '%s' '%s' ! %s\n",
		pDayName, pTaskName, pJobName );
	return NULL;
}

/******************************************************************************/
/* End of file */
