/* file variable.h */
/*
 *      Diogene87
 *	Copyright (C) 2003-2004 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef VARIABLE_H 
#define VARIABLE_H 1

#include "global.h"
#include "target.h"

typedef struct dg87_variable_struct
{
	char name[DG87_VARIABLE_NAME_LENGTH];
	char* pValue; /* can't be NULL */
	int linkedConditions; /* number of conditions which use this variable*/
} dg87_variable;

/*
 * dg87_variable_new 
 * create a new variable and initialize the name property
 */
dg87_variable* dg87_variable_new(char* pName, char* pValue);

/*
 * dg87_variable_delete
 */
BOOL dg87_variable_delete(dg87_variable* pVariable);

/*
 * dg87_variable_load
 */
BOOL dg87_variable_load(dg87_variable* pVariable, dg87_storage* pStorage);

/*
 * dg87_variable_save
 */
BOOL dg87_variable_save(dg87_variable* pVariable, dg87_storage* pStorage);

/*
 * dg87_variable_setValue
 */
BOOL dg87_variable_setValue(dg87_variable* pVariable, char* pValue);


#ifdef DEBUG
/*
 * dg87_variable_ckeck
 */
int dg87_variable_check(dg87_variable* pVariable, int (*print)(char*));
#endif /*DEBUG*/

#endif
/* End of file */
