/* file daemon.h */
/*
 *      Diogene87
 *	Copyright (C) 2003-2004 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef DG87_DAEMON_H
#define DG87_DAEMON_H 1

#include "global.h"

typedef struct{
	char* pName; /* name of the daemon for the log */
	char* pUserName; /* name of the user account to use (can be NULL) */
} dg87_daemon;

/*
 * dg87_daemon_start
 * create a new daemon objet an return a reference on this object.
 */
dg87_daemon* dg87_daemon_new(char* pName, char* pUserName);

/*
 * dg87_daemon_start
 * make a fork of the current process
 * return 0 to the parent process.
 * return 1 to the child process.
 * return -1 if an error occures
 */
int dg87_daemon_start(dg87_daemon* pDaemon);

/*
 * dg87_daemon_stop
 */
void dg87_daemon_stop(dg87_daemon* pDaemon);

/*
 * dg87_daemon_delete
 * close and delete the lock file.
 * free memory of the object.
 */
void dg87_daemon_delete(dg87_daemon* pDaemon);


/*
 * dg87_daemon_log
 */
void dg87_daemon_log(char* pMessage);

#endif /*DG87_DAEMON_H*/
/* End of file */
