/* file dgerr.c */
/*
 *      Diogene87
 *	Copyright (C) 2003-2004 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#include "dgerr.h"
#include <stdio.h>
#include <stdlib.h>

int dg87_err = 0;

char* dg87_errstr[] = {
	"No error",
	"Out of memory",
	"Key not unique",
	"Parameter is NULL",
	"Incorrect value for parameter",
	"Incorrect value for key",
	"Jobs must be in the same task to have a dependence",
	"Can't delete target because tasks use this target.",
	"Can't delete target because it has queue.",
	"Can't delete task because it has dependences with other tasks",
	"Index out of bound",
	"Can't find an object associate to this key",
	"Can't find an object with this key",
	"The description is to long",
	"The name is to long",
	"Can't delete task because it has dependences with other tasks",
	"Jobs must be in the same task to have a dependence",
	"Can't find job before",
	"Can't find job after",
	"Incorrect Condition Type",
	"Can't find task before",
	"Can't find task after",
	"Plan is in progress",
	"No Plan is in progress",
	"Circular reference with rules",
	"Rule used by other rules",
	"Rule used by tasks",
	"Operator must be 'add' with 'always' rule",
	"Operator must be 'add' or 'remove' with complex rule.",
	"Circular dependence.",
	"The day is unlocked",
	"Connection is not waiting request.",
	"Connection is not waiting response.",
	"Connection error",
	"Can't get hostname",
	"Socket connection error",
	"Connection message not available",
	"Connection is not waiting message",
	"Unknown command",
	"Interpret error",
	"User connected",
	"Can't fork",
	"A similair job is already in the list",
	"Syntax error in argument string",
	"Password to long.",
	"Permission denied",
	"Can't delete a system account.",
	"Can't change privilege of a system account.",
	"Variable used by rules",
	"Variable used by conditions.", 
	"Can't open configuration file.",
	"Syntax error in configuration file.",
	"Unknown field name in configuration file.",
	"Wrong mode",
	"Can't open file",
	"Can't close file",
	"Wrong file signature",
	"Wrong file format version"
};
/***************************************************************************/
void dg87_err_setError(int numErr)
{
	dg87_err = numErr;
}

/***************************************************************************/
void dg87_err_clearError(void)
{
	dg87_err = 0;
}

/***************************************************************************/
char* dg87_err_getErrorStr()
{
	return dg87_errstr[dg87_err];
}

/***************************************************************************/
/* End of file */
