/* file dgerr.h */
/*
 *      Diogene87
 *	Copyright (C) 2003-2004 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */


#ifndef ERROR_H
#define ERROR_H 1

#define DG87_ERR_BASE 1000;

#define DG87_ERR_OUTOFMEMORY 1
#define DG87_ERR_KEYNOTUNIQUE 2
#define DG87_ERR_NULLPARAMETER 3
#define DG87_ERR_INCORRECTVALUE 4
#define DG87_ERR_INCORRECTKEY 5
#define DG87_ERR_JOBSNOTINSAMETASK 6
#define DG87_ERR_TARGETUSEBYTASK 7
#define DG87_ERR_TARGETHASQUEUE 8
#define DG87_ERR_TASKHASDEPENDENCES 9
#define DG87_ERR_INDEXOUTOFBOUND 10
#define DG87_ERR_CANNOTFINDOBJECT 11
#define DG87_ERR_CANTFINDOBJECT 12
#define DG87_ERR_DESCRIPTIONTOLONG 13
#define DG87_ERR_NAMETOLONG 14
#define DG87_ERR_XTASKHASDEPENDENCES 15
#define DG87_ERR_XJOBSNOTINSAMEXTASK 16
#define DG87_ERR_CANNOTFINDJOBBEFORE 17
#define DG87_ERR_CANNOTFINDJOBAFTER 18
#define DG87_ERR_INCORRECTCONDITIONTYPE 19
#define DG87_ERR_CANNOTFINDTASKBEFORE 20 
#define DG87_ERR_CANNOTFINDTASKAFTER 21 
#define DG87_ERR_PLANINPROGRESS 22
#define DG87_ERR_NOPLANINPROGRESS 23
#define DG87_ERR_CIRCULARRULEREFERENCE 24
#define DG87_ERR_RULEUSEDBYANOTERRULE 25
#define DG87_ERR_RULEUSEDBYTASK 26
#define DG87_ERR_RULEWRONGOPERATORALWAYS 27
#define DG87_ERR_RULEWRONGOPERATORCOMPLEX 28
#define DG87_ERR_CIRCULARDEPENDENCE 29
#define DG87_ERR_DAYISUNLOCKED 30
#define DG87_ERR_CNXISNOTWAITINGREQUEST 31 
#define DG87_ERR_CNXISNOTWAITINGRESPONSE 32
#define DG87_ERR_CNXCANTCONNECT 33
#define DG87_ERR_CNXCANTGETHOSTBYNAME 34
#define DG87_ERR_CNXSOCKET 35
#define DG87_ERR_CNXMESSAGENOTAVAILABLE 36
#define DG87_ERR_CNXNOTWAITINGMESSAGE 37
#define DG87_ERR_UNKNOWNCOMMAND 38
#define DG87_ERR_INTERPRETERROR 39 
#define DG87_ERR_USERCONNECTED 40
#define DG87_ERR_CANTFORK 41
#define DG87_ERR_SAMEJOBALREADYEXIST 42
#define DG87_ERR_ARGUMENTSYTANXERROR 43
#define DG87_ERR_PASSWORDTOLONG	44
#define DG87_ERR_PERMDENIED 45
#define DG87_ERR_CANTDELETESYSTEMACCOUNT 46
#define DG87_ERR_CANTCHANGESYSTEMACCOUNT 47
#define DG87_ERR_VARIABLEUSEDBYRULES	48
#define DG87_ERR_VARIABLEUSEDBYCONDITIONS 49
#define DG87_ERR_CANTOPENCONFIGFILE 50
#define DG87_ERR_CONFSYNTAXERROR 51
#define DG87_ERR_CONFUNKNOWNFIELDNAME 52
#define DG87_ERR_STORAGEWRONGMODE 53
#define DG87_ERR_STORAGECANTOPEN 54
#define DG87_ERR_STORAGECANTCLOSE 55
#define DG87_ERR_STORAGEWRONGSIGN 56
#define DG87_ERR_STORAGEWRONGVERSION 57

void dg87_err_setError(int numErr);
void dg87_err_clearError(void);
char* dg87_err_getErrorStr();

#endif/*ERROR_H*/
