/* file element.c */
/*
 *      Diogene87
 *	Copyright (C) 2003-2004 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "element.h"

/****************************************************************************/
dg87_element* dg87_element_new(void* pObject, char* pKey)
{
	dg87_element* pElement;
	assert(pObject != NULL && pKey != NULL);
	if (pObject == NULL || pKey == NULL){
		dg87_err_setError(DG87_ERR_NULLPARAMETER);
		return NULL;
	}
	if (strlen(pKey) == 0) {
		dg87_err_setError(DG87_ERR_INCORRECTKEY);
		return NULL;
	}

	pElement = dg87_malloc(sizeof(dg87_element), DG87_ELEMENT);
	if (pElement == NULL){
		dg87_err_setError(DG87_ERR_OUTOFMEMORY);
		return NULL;
	}

	pElement->pKey = pKey;
	pElement->pObject = pObject;
	pElement->pNext = NULL;
	pElement->pPrev = NULL;

	return pElement;
}

/****************************************************************************/
BOOL dg87_element_delete(void* pElement)
{
	assert(pElement != NULL);
	if (pElement == NULL) 
		return FALSE;

	dg87_free(pElement, DG87_ELEMENT);

	return TRUE;
}
/****************************************************************************/


/* End of file */
