/* file element.h */
/*
 *      Diogene87
 *	Copyright (C) 2003-2004 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef ELEMENT_H
#define ELEMENT_H 1

#include "global.h"

typedef struct dg87_struct_element{
	char* pKey;
	void* pObject;
	struct dg87_struct_element *pNext;
	struct dg87_struct_element *pPrev;
}dg87_element;

/*
 * dg87_element_new
 * allocate and initialize an dg87_element object.
 */
dg87_element* dg87_element_new(void* pObject, char* pKey);

/*
 * dg87_element_delete
 * free memory of the dg87_element object.
 * The object and the key are not delete !
 */
BOOL dg87_element_delete(void* pObject);

#endif
/* End of file */
