/* file interpret.h */
/*
 *      Diogene87
 *	Copyright (C) 2003-2004 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef INTERPRET_H
#define INTERPRET_H

#include "global.h"
#include "user.h"
#include "connection.h"
#include "stdio.h"

/* structure for a command */
typedef struct dg87_interpret_cmd_struct
{
	char* pName;
	int (*pFunction)(struct dg87_connection_struct*);
	char* pHelp;
	char* pOptStr;
	dg87_command_family family;
	dg87_command_privilege privilege;
}dg87_interpret_cmd; 

/* dg87_interpret object */
typedef struct dg87_interpret_struct{
	struct dg87_server_struct* pServer;
	/* array of functions */
	struct dg87_interpret_cmd_struct *pCmdArray;
} dg87_interpret;

/*
 * dg87_interpret_new
 */
dg87_interpret* dg87_interpret_new(struct dg87_server_struct* pServer,
		struct dg87_interpret_cmd_struct *pCmdArray);

/*
 * dg87_interpret_delete
 */
BOOL dg87_interpret_delete(dg87_interpret* pInterpret);


/*
 * dg87_interpret_execute
 * this function interprete the command given in parameter
 */
int dg87_interpret_execute(dg87_interpret* pInterpret,
		struct dg87_connection_struct* pConnection);

#endif /*INTERPRET_H*/
/* End of file */
