/* file item.c */
/*
 *      Diogene87
 *	Copyright (C) 2003-2004 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "item.h"

/**************************************************************************/
dg87_item* dg87_item_new(void* pObject)
{
	dg87_item* pItem;
	assert(pObject != NULL);
	if (pObject == NULL){
		dg87_err_setError(DG87_ERR_NULLPARAMETER);
		return NULL;
	}
	pItem = dg87_malloc(sizeof(dg87_item), DG87_ITEM);
	if (pItem == NULL) {
		dg87_err_setError(DG87_ERR_OUTOFMEMORY);
		return NULL;
	}
	pItem->pObject = pObject;
	pItem->pPrev = NULL;
	pItem->pNext = NULL;
	return pItem;
}
/**************************************************************************/
BOOL dg87_item_delete(dg87_item* pItem)
{
	assert(pItem != NULL);
	if (pItem == NULL)
		return FALSE;
	dg87_free(pItem, DG87_ITEM);
	return TRUE;
}
/**************************************************************************/
dg87_item* dg87_item_getNext(dg87_item* pItem)
{
	assert(pItem != NULL);
	if (pItem == NULL)
		return FALSE;
	return pItem->pNext;
}
/**************************************************************************/
dg87_item* dg87_item_getPrev(dg87_item* pItem)
{
	assert(pItem != NULL);
	if (pItem == NULL)
		return FALSE;
	return pItem->pPrev;
}
/**************************************************************************/

/* End of file */
