/* file message.h */
/*
 *      Diogene87
 *	Copyright (C) 2003-2004 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef MESSAGE_H 
#define MESSAGE_H 1
#include <time.h>
#include "global.h"
#include "connection.h"
#include "server.h"


typedef enum {
	dg87_message_state_notConnected,
	dg87_message_state_readBanner,
	dg87_message_state_sendUser,
	dg87_message_state_readUserResponse,
	dg87_message_state_sendMessage,
	dg87_message_state_readResponse,
	dg87_message_state_cancel,
	dg87_message_state_bannerError,
	dg87_message_state_authError
} dg87_message_state;
	
typedef struct{
	char* pMsgString;
	char* pHost;
	int ipPort;
	struct dg87_connection_struct* pConnection;
	dg87_message_state state;
	time_t lastConnectionRetry;
} dg87_message;

/*
 * dg87_message_new
 */
dg87_message* dg87_message_new(char* pHost, int ipPort, char* pMsgString);

/*
 * dg87_message_delete
 */
BOOL dg87_message_delete(dg87_message* pMessage);

/*
 * dg87_message_send
 */
BOOL dg87_message_send(dg87_message* pMessage, dg87_server *pServer);

/*
 * dg87_message_cancel
 */
BOOL dg87_message_cancel(dg87_message* pMessage);

/*
 * dg87_message_stateToAscii
 */
char* dg87_message_stateToAscii(dg87_message_state state);

#endif /* MESSAGE_H */
/* End of file */
