/* file strbuf.h */
/*
 *      Diogene87
 *	Copyright (C) 2003-2004 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef STRBUF_H 
#define STRBUF_H 1
#include "global.h"

#define DG87_STRBUF_BUFFERSIZE 512

typedef struct dg87_struct_strbuf
{
	char* pBuffer;
	int size;
	int bufferSize;
} dg87_strbuf;

/*
 * dg87_strbuf_new
 */
dg87_strbuf* dg87_strbuf_new(void);

/*
 * dg87_strbuf_delete
 */
BOOL dg87_strbuf_delete(dg87_strbuf* pStrbuf);

/*
 * dg87_strbuf_getBuffer
 * return a pointer on a string (terminated by a null character)
 * and reinitialize the string buffer (empty string).
 */
char* dg87_strbuf_getBuffer(dg87_strbuf* pStrbuf);

/*
 * dg87_strbuf_cat
 * concat a string to the buffer string. 
 */
BOOL dg87_strbuf_cat(dg87_strbuf* pStrbuf, char* pString);

/*
 * dg87_strbuf_ncat
 * concat 'size' characters of a string to a string buffer.
 */
BOOL dg87_strbuf_ncat(dg87_strbuf* pStrbuf, char* pString, int size);

/*
 * dg87_strbuf_cpy
 * copy a string at the end of a string buffer.
 */
BOOL dg87_strbuf_cpy(dg87_strbuf* pStrbuf, char* pString);

/*
 * dg87_strbuf_ncpy
 * copy 'size' characters of a string at the end of a string buffer.
 */
BOOL dg87_strbuf_ncpy(dg87_strbuf* pStrbuf, char* pString, int size);

/*
 * dg87_strbuf_printf
 * this function is an equivalent of `printf' function.
 */
BOOL dg87_strbuf_printf(dg87_strbuf* pStrbuf, char* pFormat, ...);

#endif /*STRBUF_H*/

/* End of file */
